/*
 Highstock JS v9.2.1 (2021-08-19)

 All technical indicators for Highcharts Stock

 (c) 2010-2021 Pawel Fus

 License: www.highcharts.com/license
*/
'use strict';(function(d){"object"===typeof module&&module.exports?(d["default"]=d,module.exports=d):"function"===typeof define&&define.amd?define("highcharts/indicators/indicators-all",["highcharts","highcharts/modules/stock"],function(t){d(t);d.Highcharts=t;return d}):d("undefined"!==typeof Highcharts?Highcharts:void 0)})(function(d){function t(d,e,h,k){d.hasOwnProperty(e)||(d[e]=k.apply(null,h))}d=d?d._modules:{};t(d,"Mixins/IndicatorRequired.js",[d["Core/Utilities.js"]],function(d){var e=d.error;
return{isParentLoaded:function(h,d,m,n,r){if(h)return n?n(h):!0;e(r||this.generateMessage(m,d));return!1},generateMessage:function(e,d){return'Error: "'+e+'" indicator type requires "'+d+'" indicator loaded before. Please read docs: https://api.highcharts.com/highstock/plotOptions.'+e}}});t(d,"Stock/Indicators/SMA/SMAComposition.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=d.series,k=d.seriesTypes.ohlc.prototype;d=e.addEvent;var m=e.extend;d(h,"init",function(e){e=
e.options;e.useOhlcData&&"highcharts-navigator-series"!==e.id&&m(this,{pointValKey:k.pointValKey,pointArrayMap:k.pointArrayMap,toYData:k.toYData})});d(h,"afterSetOptions",function(e){e=e.options;var h=e.dataGrouping;h&&e.useOhlcData&&"highcharts-navigator-series"!==e.id&&(h.approximation="ohlc")})});t(d,"Stock/Indicators/SMA/SMAIndicator.js",[d["Core/Chart/Chart.js"],d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h,k){var m=this&&this.__extends||
function(){var f=function(b,a){f=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(f,b){f.__proto__=b}||function(f,b){for(var a in b)b.hasOwnProperty(a)&&(f[a]=b[a])};return f(b,a)};return function(b,a){function c(){this.constructor=b}f(b,a);b.prototype=null===a?Object.create(a):(c.prototype=a.prototype,new c)}}(),n=h.seriesTypes.line,r=k.addEvent,l=k.error,g=k.extend,c=k.isArray,a=k.merge,b=k.pick,f=k.splat,x=e.generateMessage;e=function(g){function v(){var f=null!==g&&g.apply(this,
arguments)||this;f.data=void 0;f.dataEventsToUnbind=void 0;f.linkedParent=void 0;f.options=void 0;f.points=void 0;return f}m(v,g);v.prototype.destroy=function(){this.dataEventsToUnbind.forEach(function(f){f()});g.prototype.destroy.apply(this,arguments)};v.prototype.getName=function(){var f=this.name,a=[];f||((this.nameComponents||[]).forEach(function(f,c){a.push(this.options.params[f]+b(this.nameSuffixes[c],""))},this),f=(this.nameBase||this.type.toUpperCase())+(this.nameComponents?" ("+a.join(", ")+
")":""));return f};v.prototype.getValues=function(f,a){var b=a.period,x=f.xData;f=f.yData;var g=f.length,v=0,C=0,y=[],l=[],e=[],E=-1;if(!(x.length<b)){for(c(f[0])&&(E=a.index?a.index:0);v<b-1;)C+=0>E?f[v]:f[v][E],v++;for(a=v;a<g;a++){C+=0>E?f[a]:f[a][E];var h=[x[a],C/b];y.push(h);l.push(h[0]);e.push(h[1]);C-=0>E?f[a-v]:f[a-v][E]}return{values:y,xData:l,yData:e}}};v.prototype.init=function(f,a){var b=this,c=b.requireIndicators();if(!c.allLoaded)return l(x(b.type,c.needed));g.prototype.init.call(b,
f,a);a=r(d,"afterLinkSeries",function(){var a=!!b.dataEventsToUnbind.length;if(b.linkedParent)if(a||b.dataEventsToUnbind.push(r(b.bindTo.series?b.linkedParent:b.linkedParent.xAxis,b.bindTo.eventName,function(){b.recalculateValues()})),"init"===b.calculateOn)b.processedYData||b.recalculateValues();else{if(!a)var c=r(b.chart,b.calculateOn,function(){b.recalculateValues();c()})}else return l("Series "+b.options.linkedTo+" not found! Check `linkedTo`.",!1,f)},{order:0});b.dataEventsToUnbind=[];b.eventsToUnbind.push(a)};
v.prototype.recalculateValues=function(){var b=this.points||[],a=(this.xData||[]).length,c=this.getValues(this.linkedParent,this.options.params)||{values:[],xData:[],yData:[]},x=[],g=!0;if(a&&!this.hasGroupedData&&this.visible&&this.points)if(this.cropped){if(this.xAxis){var v=this.xAxis.min;var y=this.xAxis.max}a=this.cropData(c.xData,c.yData,v,y);for(v=0;v<a.xData.length;v++)x.push([a.xData[v]].concat(f(a.yData[v])));a=c.xData.indexOf(this.xData[0]);v=c.xData.indexOf(this.xData[this.xData.length-
1]);-1===a&&v===c.xData.length-2&&x[0][0]===b[0].x&&x.shift();this.updateData(x)}else c.xData.length!==a-1&&c.xData.length!==a+1&&(g=!1,this.updateData(c.values));g&&(this.xData=c.xData,this.yData=c.yData,this.options.data=c.values);!1===this.bindTo.series&&(delete this.processedXData,this.isDirty=!0,this.redraw());this.isDirtyData=!1};v.prototype.processData=function(){var f=this.options.compareToMain,a=this.linkedParent;g.prototype.processData.apply(this,arguments);a&&a.compareValue&&f&&(this.compareValue=
a.compareValue)};v.prototype.requireIndicators=function(){var f={allLoaded:!0};this.requiredIndicators.forEach(function(a){h.seriesTypes[a]?h.seriesTypes[a].prototype.requireIndicators():(f.allLoaded=!1,f.needed=a)});return f};v.defaultOptions=a(n.defaultOptions,{name:void 0,tooltip:{valueDecimals:4},linkedTo:void 0,compareToMain:!1,params:{index:0,period:14}});return v}(n);g(e.prototype,{bindTo:{series:!0,eventName:"updatedData"},calculateOn:"init",hasDerivedData:!0,nameComponents:["period"],nameSuffixes:[],
requiredIndicators:[],useCommonDataGrouping:!0});h.registerSeriesType("sma",e);"";return e});t(d,"Stock/Indicators/AD/ADIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var l=function(g,c){l=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return l(g,c)};return function(g,c){function a(){this.constructor=g}l(g,c);g.prototype=
null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.error,n=e.extend,r=e.merge;e=function(l){function g(){var c=null!==l&&l.apply(this,arguments)||this;c.data=void 0;c.options=void 0;c.points=void 0;return c}h(g,l);g.populateAverage=function(c,a,b,f,x){x=a[f][1];var g=a[f][2];a=a[f][3];b=b[f];return[c[f],a===x&&a===g||x===g?0:(2*a-g-x)/(x-g)*b]};g.prototype.getValues=function(c,a){var b=a.period,f=c.xData,x=c.yData,v=a.volumeSeriesID,y=c.chart.get(v);a=y&&y.yData;
var C=x?x.length:0,l=[],e=[],q=[];if(!(f.length<=b&&C&&4!==x[0].length)){if(y){for(v=b;v<C;v++)c=l.length,y=g.populateAverage(f,x,a,v,b),0<c&&(y[1]+=l[c-1][1]),l.push(y),e.push(y[0]),q.push(y[1]);return{values:l,xData:e,yData:q}}m("Series "+v+" not found! Check `volumeSeriesID`.",!0,c.chart)}};g.defaultOptions=r(k.defaultOptions,{params:{index:void 0,volumeSeriesID:"volume"}});return g}(k);n(e.prototype,{nameComponents:!1,nameBase:"Accumulation/Distribution"});d.registerSeriesType("ad",e);"";return e});
t(d,"Stock/Indicators/AO/AOIndicator.js",[d["Core/Globals.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"],d["Core/Color/Palette.js"]],function(d,e,h,k){var m=this&&this.__extends||function(){var a=function(f,b){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=f}||function(a,f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return a(f,b)};return function(f,b){function c(){this.constructor=f}a(f,b);f.prototype=null===b?Object.create(b):(c.prototype=
b.prototype,new c)}}();d=d.noop;var n=e.seriesTypes,r=n.sma;n=n.column;var l=h.extend,g=h.merge,c=h.correctFloat,a=h.isArray;h=function(b){function f(){var f=null!==b&&b.apply(this,arguments)||this;f.data=void 0;f.options=void 0;f.points=void 0;return f}m(f,b);f.prototype.drawGraph=function(){var f=this.options,a=this.points,b=f.greaterBarColor;f=f.lowerBarColor;var c=a[0];if(!this.userOptions.color&&c)for(c.color=b,c=1;c<a.length;c++)a[c].color=a[c].y>a[c-1].y?b:a[c].y<a[c-1].y?f:a[c-1].color};f.prototype.getValues=
function(f){var b=f.xData||[];f=f.yData||[];var g=f.length,x=[],l=[],e=[],q=0,A=0,p;if(!(34>=b.length)&&a(f[0])&&4===f[0].length){for(p=0;33>p;p++){var u=(f[p][1]+f[p][2])/2;29<=p&&(q=c(q+u));A=c(A+u)}for(p=33;p<g;p++){u=(f[p][1]+f[p][2])/2;q=c(q+u);A=c(A+u);u=q/5;var h=A/34;u=c(u-h);x.push([b[p],u]);l.push(b[p]);e.push(u);u=p+1-5;h=p+1-34;q=c(q-(f[u][1]+f[u][2])/2);A=c(A-(f[h][1]+f[h][2])/2)}return{values:x,xData:l,yData:e}}};f.defaultOptions=g(r.defaultOptions,{params:{index:void 0,period:void 0},
greaterBarColor:k.positiveColor,lowerBarColor:k.negativeColor,threshold:0,groupPadding:.2,pointPadding:.2,crisp:!1,states:{hover:{halo:{size:0}}}});return f}(r);l(h.prototype,{nameBase:"AO",nameComponents:!1,markerAttribs:d,getColumnMetrics:n.prototype.getColumnMetrics,crispCol:n.prototype.crispCol,translate:n.prototype.translate,drawPoints:n.prototype.drawPoints});e.registerSeriesType("ao",h);"";return h});t(d,"Mixins/MultipleLines.js",[d["Core/Globals.js"],d["Core/Utilities.js"]],function(d,e){var h=
e.defined,k=e.error,m=e.merge,n=d.seriesTypes.sma;return{pointArrayMap:["top","bottom"],pointValKey:"top",linesApiNames:["bottomLine"],getTranslatedLinesNames:function(e){var l=[];(this.pointArrayMap||[]).forEach(function(g){g!==e&&l.push("plot"+g.charAt(0).toUpperCase()+g.slice(1))});return l},toYData:function(e){var l=[];(this.pointArrayMap||[]).forEach(function(g){l.push(e[g])});return l},translate:function(){var e=this,l=e.pointArrayMap,g=[],c,a=e.modifyValue;g=e.getTranslatedLinesNames();n.prototype.translate.apply(e,
arguments);e.points.forEach(function(b){l.forEach(function(f,x){c=b[f];a&&(c=a.call(e,c));null!==c&&(b[g[x]]=e.yAxis.toPixels(c,!0))})})},drawGraph:function(){var e=this,l=e.linesApiNames,g=e.points,c=g.length,a=e.options,b=e.graph,f={options:{gapSize:a.gapSize}},x=[],v;e.getTranslatedLinesNames(e.pointValKey).forEach(function(f,a){for(x[a]=[];c--;)v=g[c],x[a].push({x:v.x,plotX:v.plotX,plotY:v[f],isNull:!h(v[f])});c=g.length});l.forEach(function(b,c){x[c]?(e.points=x[c],a[b]?e.options=m(a[b].styles,
f):k('Error: "There is no '+b+' in DOCS options declared. Check if linesApiNames are consistent with your DOCS line names." at mixin/multiple-line.js:34'),e.graph=e["graph"+b],n.prototype.drawGraph.call(e),e["graph"+b]=e.graph):k('Error: "'+b+" doesn't have equivalent in pointArrayMap. To many elements in linesApiNames relative to pointArrayMap.\"")});e.points=g;e.options=a;e.graph=b;n.prototype.drawGraph.call(e)}}});t(d,"Stock/Indicators/Aroon/AroonIndicator.js",[d["Mixins/MultipleLines.js"],d["Core/Series/SeriesRegistry.js"],
d["Core/Utilities.js"]],function(d,e,h){function k(c,a){var b=c[0],f=0,g;for(g=1;g<c.length;g++)if("max"===a&&c[g]>=b||"min"===a&&c[g]<=b)b=c[g],f=g;return f}var m=this&&this.__extends||function(){var c=function(a,b){c=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(f,a){f.__proto__=a}||function(f,a){for(var b in a)a.hasOwnProperty(b)&&(f[b]=a[b])};return c(a,b)};return function(a,b){function f(){this.constructor=a}c(a,b);a.prototype=null===b?Object.create(b):(f.prototype=b.prototype,
new f)}}(),n=e.seriesTypes.sma,r=h.extend,l=h.merge,g=h.pick;h=function(c){function a(){var a=null!==c&&c.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}m(a,c);a.prototype.getValues=function(a,f){f=f.period;var b=a.xData,c=(a=a.yData)?a.length:0,e=[],l=[],h=[],z;for(z=f-1;z<c;z++){var q=a.slice(z-f+1,z+2);var A=k(q.map(function(a){return g(a[2],a)}),"min");q=k(q.map(function(a){return g(a[1],a)}),"max");q=q/f*100;A=A/f*100;b[z+1]&&(e.push([b[z+1],q,A]),l.push(b[z+
1]),h.push([q,A]))}return{values:e,xData:l,yData:h}};a.defaultOptions=l(n.defaultOptions,{params:{index:void 0,period:25},marker:{enabled:!1},tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span><b> {series.name}</b><br/>Aroon Up: {point.y}<br/>Aroon Down: {point.aroonDown}<br/>'},aroonDown:{styles:{lineWidth:1,lineColor:void 0}},dataGrouping:{approximation:"averages"}});return a}(n);r(h.prototype,{linesApiNames:["aroonDown"],nameBase:"Aroon",pointArrayMap:["y","aroonDown"],pointValKey:"y",
drawGraph:d.drawGraph,getTranslatedLinesNames:d.getTranslatedLinesNames,toYData:d.toYData,translate:d.translate});e.registerSeriesType("aroon",h);"";return h});t(d,"Stock/Indicators/AroonOscillator/AroonOscillatorIndicator.js",[d["Mixins/MultipleLines.js"],d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h,k){var m=this&&this.__extends||function(){var c=function(a,b){c=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=
b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return c(a,b)};return function(a,b){function f(){this.constructor=a}c(a,b);a.prototype=null===b?Object.create(b):(f.prototype=b.prototype,new f)}}(),n=h.seriesTypes.aroon,r=k.extend,l=k.merge,g=h.seriesTypes.aroon;k=function(c){function a(){var a=null!==c&&c.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}m(a,c);a.prototype.getValues=function(a,f){var b=[],c=[],e=[];a=g.prototype.getValues.call(this,
a,f);for(f=0;f<a.yData.length;f++){var l=a.yData[f][0];var h=a.yData[f][1];l-=h;b.push([a.xData[f],l]);c.push(a.xData[f]);e.push(l)}return{values:b,xData:c,yData:e}};a.prototype.init=function(){var a=arguments,f=this;e.isParentLoaded(g,"aroon",f.type,function(b){b.prototype.init.apply(f,a)})};a.defaultOptions=l(n.defaultOptions,{tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span><b> {series.name}</b>: {point.y}'}});return a}(n);r(k.prototype,l(d,{nameBase:"Aroon Oscillator",pointArrayMap:["y"],
pointValKey:"y",linesApiNames:[]}));h.registerSeriesType("aroonoscillator",k);"";return k});t(d,"Stock/Indicators/ATR/ATRIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){function h(e,g){return Math.max(e[1]-e[2],"undefined"===typeof g?0:Math.abs(e[1]-g[3]),"undefined"===typeof g?0:Math.abs(e[2]-g[3]))}var k=this&&this.__extends||function(){var e=function(g,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&
(a[f]=b[f])};return e(g,c)};return function(g,c){function a(){this.constructor=g}e(g,c);g.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),m=d.seriesTypes.sma,n=e.isArray,r=e.merge;e=function(e){function g(){var c=null!==e&&e.apply(this,arguments)||this;c.data=void 0;c.points=void 0;c.options=void 0;return c}k(g,e);g.prototype.getValues=function(c,a){a=a.period;var b=c.xData,f=(c=c.yData)?c.length:0,g=1,v=0,e=0,l=[],d=[],z=[],q;var A=[[b[0],c[0]]];if(!(b.length<=a)&&n(c[0])&&
4===c[0].length){for(q=1;q<=f;q++)if(A.push([b[q],c[q]]),a<g){var p=a;var u=b[q-1],k=h(c[q-1],c[q-2]);p=[u,(v*(p-1)+k)/p];v=p[1];l.push(p);d.push(p[0]);z.push(p[1])}else a===g?(v=e/(q-1),l.push([b[q-1],v]),d.push(b[q-1]),z.push(v)):e+=h(c[q-1],c[q-2]),g++;return{values:l,xData:d,yData:z}}};g.defaultOptions=r(m.defaultOptions,{params:{index:void 0}});return g}(m);d.registerSeriesType("atr",e);"";return e});t(d,"Stock/Indicators/BB/BBIndicator.js",[d["Mixins/MultipleLines.js"],d["Core/Series/SeriesRegistry.js"],
d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var g=function(c,a){g=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=f}||function(a,f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return g(c,a)};return function(c,a){function b(){this.constructor=c}g(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),m=e.seriesTypes.sma,n=h.extend,r=h.isArray,l=h.merge;h=function(g){function c(){var a=null!==g&&g.apply(this,
arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(c,g);c.prototype.init=function(){e.seriesTypes.sma.prototype.init.apply(this,arguments);this.options=l({topLine:{styles:{lineColor:this.color}},bottomLine:{styles:{lineColor:this.color}}},this.options)};c.prototype.getValues=function(a,b){var f=b.period,c=b.standardDeviation,g=a.xData,l=(a=a.yData)?a.length:0,C=[],h=[],z=[],q;if(!(g.length<f)){var A=r(a[0]);for(q=f;q<=l;q++){var p=g.slice(q-f,q);var u=a.slice(q-f,q);var d=
e.seriesTypes.sma.prototype.getValues.call(this,{xData:p,yData:u},b);p=d.xData[0];d=d.yData[0];for(var k=0,m=u.length,n=0;n<m;n++){var w=(A?u[n][b.index]:u[n])-d;k+=w*w}w=Math.sqrt(k/(m-1));u=d+c*w;w=d-c*w;C.push([p,u,d,w]);h.push(p);z.push([u,d,w])}return{values:C,xData:h,yData:z}}};c.defaultOptions=l(m.defaultOptions,{params:{period:20,standardDeviation:2,index:3},bottomLine:{styles:{lineWidth:1,lineColor:void 0}},topLine:{styles:{lineWidth:1,lineColor:void 0}},tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span><b> {series.name}</b><br/>Top: {point.top}<br/>Middle: {point.middle}<br/>Bottom: {point.bottom}<br/>'},
marker:{enabled:!1},dataGrouping:{approximation:"averages"}});return c}(m);n(h.prototype,{pointArrayMap:["top","middle","bottom"],pointValKey:"middle",nameComponents:["period","standardDeviation"],linesApiNames:["topLine","bottomLine"],drawGraph:d.drawGraph,getTranslatedLinesNames:d.getTranslatedLinesNames,translate:d.translate,toYData:d.toYData});e.registerSeriesType("bb",h);"";return h});t(d,"Stock/Indicators/CCI/CCIIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,
e){function h(e){return e.reduce(function(g,c){return g+c},0)}var k=this&&this.__extends||function(){var e=function(g,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return e(g,c)};return function(g,c){function a(){this.constructor=g}e(g,c);g.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),m=d.seriesTypes.sma,n=e.isArray,r=e.merge;e=function(e){function g(){var c=null!==
e&&e.apply(this,arguments)||this;c.data=void 0;c.points=void 0;c.options=void 0;return c}k(g,e);g.prototype.getValues=function(c,a){a=a.period;var b=c.xData,f=(c=c.yData)?c.length:0,g=[],v=1,e=[],l=[],d=[];if(!(b.length<=a)&&n(c[0])&&4===c[0].length){for(;v<a;){var z=c[v-1];g.push((z[1]+z[2]+z[3])/3);v++}for(v=a;v<=f;v++){z=c[v-1];z=(z[1]+z[2]+z[3])/3;var q=g.push(z);var A=g.slice(q-a);q=h(A)/a;var p,u=A.length,k=0;for(p=0;p<u;p++)k+=Math.abs(q-A[p]);A=k/a;z=(z-q)/(.015*A);e.push([b[v-1],z]);l.push(b[v-
1]);d.push(z)}return{values:e,xData:l,yData:d}}};g.defaultOptions=r(m.defaultOptions,{params:{index:void 0}});return g}(m);d.registerSeriesType("cci",e);"";return e});t(d,"Stock/Indicators/CMF/CMFIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,l){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(g,c){g.__proto__=c}||function(g,c){for(var a in c)c.hasOwnProperty(a)&&(g[a]=c[a])};return e(d,
l)};return function(d,l){function g(){this.constructor=d}e(d,l);d.prototype=null===l?Object.create(l):(g.prototype=l.prototype,new g)}}(),k=d.seriesTypes.sma,m=e.merge;e=function(e){function d(){var l=null!==e&&e.apply(this,arguments)||this;l.data=void 0;l.options=void 0;l.points=void 0;l.volumeSeries=void 0;l.linkedParent=void 0;l.yData=void 0;l.nameBase="Chaikin Money Flow";return l}h(d,e);d.prototype.isValid=function(){var e=this.chart,g=this.options,c=this.linkedParent;e=this.volumeSeries||(this.volumeSeries=
e.get(g.params.volumeSeriesID));var a=c&&c.yData&&4===c.yData[0].length;return!!(c&&e&&c.xData&&c.xData.length>=g.params.period&&e.xData&&e.xData.length>=g.params.period&&a)};d.prototype.getValues=function(e,g){if(this.isValid())return this.getMoneyFlow(e.xData,e.yData,this.volumeSeries.yData,g.period)};d.prototype.getMoneyFlow=function(e,g,c,a){function b(a,f){var b=a[1],c=a[2];a=a[3];return null!==f&&null!==b&&null!==c&&null!==a&&b!==c?(a-c-(b-a))/(b-c)*f:(A=q,null)}var f=g.length,x=[],v=0,l=0,
C=[],d=[],z=[],q,A=-1;if(0<a&&a<=f){for(q=0;q<a;q++)x[q]=b(g[q],c[q]),v+=c[q],l+=x[q];C.push(e[q-1]);d.push(q-A>=a&&0!==v?l/v:null);for(z.push([C[0],d[0]]);q<f;q++){x[q]=b(g[q],c[q]);v-=c[q-a];v+=c[q];l-=x[q-a];l+=x[q];var p=[e[q],q-A>=a?l/v:null];C.push(p[0]);d.push(p[1]);z.push([p[0],p[1]])}}return{values:z,xData:C,yData:d}};d.defaultOptions=m(k.defaultOptions,{params:{index:void 0,volumeSeriesID:"volume"}});return d}(k);d.registerSeriesType("cmf",e);"";return e});t(d,"Stock/Indicators/DMI/DMIIndicator.js",
[d["Mixins/MultipleLines.js"],d["Core/Color/Palette.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h,k){var m=this&&this.__extends||function(){var a=function(b,f){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=f}||function(a,f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return a(b,f)};return function(b,f){function c(){this.constructor=b}a(b,f);b.prototype=null===f?Object.create(f):(c.prototype=f.prototype,new c)}}(),n=h.seriesTypes.sma,
r=k.correctFloat,l=k.extend,g=k.isArray,c=k.merge;k=function(a){function b(){return null!==a&&a.apply(this,arguments)||this}m(b,a);b.prototype.calculateDM=function(a,b,c){var f=a[b][1],g=a[b][2],x=a[b-1][1];a=a[b-1][2];return r(f-x>a-g?c?Math.max(f-x,0):0:c?0:Math.max(a-g,0))};b.prototype.calculateDI=function(a,b){return a/b*100};b.prototype.calculateDX=function(a,b){return r(Math.abs(a-b)/Math.abs(a+b)*100)};b.prototype.smoothValues=function(a,b,c){return r(a-a/c+b)};b.prototype.getTR=function(a,
b){return r(Math.max(a[1]-a[2],b?Math.abs(a[1]-b[3]):0,b?Math.abs(a[2]-b[3]):0))};b.prototype.getValues=function(a,b){b=b.period;var f=a.xData,c=(a=a.yData)?a.length:0,x=[],e=[],l=[];if(!(f.length<=b)&&g(a[0])&&4===a[0].length){var q=0,A=0,p=0,d;for(d=1;d<c;d++)if(d<=b){var h=this.calculateDM(a,d,!0);var k=this.calculateDM(a,d);var m=this.getTR(a[d],a[d-1]);q+=h;A+=k;p+=m;d===b&&(m=this.calculateDI(q,p),k=this.calculateDI(A,p),h=this.calculateDX(q,A),x.push([f[d],h,m,k]),e.push(f[d]),l.push([h,m,
k]))}else h=this.calculateDM(a,d,!0),k=this.calculateDM(a,d),m=this.getTR(a[d],a[d-1]),q=this.smoothValues(q,h,b),A=this.smoothValues(A,k,b),p=this.smoothValues(p,m,b),m=this.calculateDI(q,p),k=this.calculateDI(A,p),h=this.calculateDX(q,A),x.push([f[d],h,m,k]),e.push(f[d]),l.push([h,m,k]);return{values:x,xData:e,yData:l}}};b.defaultOptions=c(n.defaultOptions,{params:{index:void 0},marker:{enabled:!1},tooltip:{pointFormat:'<span style="color: {point.color}">\u25cf</span><b> {series.name}</b><br/><span style="color: {point.color}">DX</span>: {point.y}<br/><span style="color: {point.series.options.plusDILine.styles.lineColor}">+DI</span>: {point.plusDI}<br/><span style="color: {point.series.options.minusDILine.styles.lineColor}">-DI</span>: {point.minusDI}<br/>'},
plusDILine:{styles:{lineWidth:1,lineColor:e.positiveColor}},minusDILine:{styles:{lineWidth:1,lineColor:e.negativeColor}},dataGrouping:{approximation:"averages"}});return b}(n);l(k.prototype,{nameBase:"DMI",pointArrayMap:["y","plusDI","minusDI"],parallelArrays:["x","y","plusDI","minusDI"],pointValKey:"y",linesApiNames:["plusDILine","minusDILine"],drawGraph:d.drawGraph,getTranslatedLinesNames:d.getTranslatedLinesNames,translate:d.translate,toYData:d.toYData});h.registerSeriesType("dmi",k);"";return k});
t(d,"Stock/Indicators/DPO/DPOIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){function h(c,a,b,f,x){a=g(a[b][f],a[b]);return x?l(c-a):l(c+a)}var k=this&&this.__extends||function(){var c=function(a,b){c=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return c(a,b)};return function(a,b){function f(){this.constructor=a}c(a,b);a.prototype=null===b?Object.create(b):
(f.prototype=b.prototype,new f)}}(),m=d.seriesTypes.sma,n=e.extend,r=e.merge,l=e.correctFloat,g=e.pick;e=function(c){function a(){var a=null!==c&&c.apply(this,arguments)||this;a.options=void 0;a.data=void 0;a.points=void 0;return a}k(a,c);a.prototype.getValues=function(a,f){var b=f.period;f=f.index;var c=b+Math.floor(b/2+1),e=a.xData||[];a=a.yData||[];var d=a.length,l=[],z=[],q=[],A=0,p,u;if(!(e.length<=c)){for(p=0;p<b-1;p++)A=h(A,a,p,f);for(u=0;u<=d-c;u++){var k=u+b-1;p=u+c-1;A=h(A,a,k,f);k=g(a[p][f],
a[p]);k-=A/b;A=h(A,a,u,f,!0);l.push([e[p],k]);z.push(e[p]);q.push(k)}return{values:l,xData:z,yData:q}}};a.defaultOptions=r(m.defaultOptions,{params:{index:0,period:21}});return a}(m);n(e.prototype,{nameBase:"DPO"});d.registerSeriesType("dpo",e);"";return e});t(d,"Stock/Indicators/EMA/EMAIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(g,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,
b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return e(g,c)};return function(g,c){function a(){this.constructor=g}e(g,c);g.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.correctFloat,n=e.isArray,r=e.merge;e=function(e){function g(){var c=null!==e&&e.apply(this,arguments)||this;c.data=void 0;c.options=void 0;c.points=void 0;return c}h(g,e);g.prototype.accumulatePeriodPoints=function(c,a,b){for(var f=0,g=0,e;g<c;)e=
0>a?b[g]:b[g][a],f+=e,g++;return f};g.prototype.calculateEma=function(c,a,b,f,g,e,d){c=c[b-1];a=0>e?a[b-1]:a[b-1][e];f="undefined"===typeof g?d:m(a*f+g*(1-f));return[c,f]};g.prototype.getValues=function(c,a){var b=a.period,f=c.xData,g=(c=c.yData)?c.length:0,e=2/(b+1),d=[],l=[],h=[],z=-1;if(!(g<b)){n(c[0])&&(z=a.index?a.index:0);a=this.accumulatePeriodPoints(b,z,c);for(a/=b;b<g+1;b++){var q=this.calculateEma(f,c,b,e,q,z,a);d.push(q);l.push(q[0]);h.push(q[1]);q=q[1]}return{values:d,xData:l,yData:h}}};
g.defaultOptions=r(k.defaultOptions,{params:{index:3,period:9}});return g}(k);d.registerSeriesType("ema",e);"";return e});t(d,"Stock/Indicators/Chaikin/ChaikinIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var a=function(b,f){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return a(b,
f)};return function(b,f){function c(){this.constructor=b}a(b,f);b.prototype=null===f?Object.create(f):(c.prototype=f.prototype,new c)}}(),m=e.seriesTypes,n=m.ad,r=m.ema,l=h.correctFloat;m=h.extend;var g=h.merge,c=h.error;h=function(a){function b(){var b=null!==a&&a.apply(this,arguments)||this;b.data=void 0;b.options=void 0;b.points=void 0;return b}k(b,a);b.prototype.init=function(){var a=arguments,b=this;d.isParentLoaded(r,"ema",b.type,function(f){f.prototype.init.apply(b,a)})};b.prototype.getValues=
function(a,b){var f=b.periods,g=b.period,e=[],x=[],d=[],q;if(2!==f.length||f[1]<=f[0])c('Error: "Chaikin requires two periods. Notice, first period should be lower than the second one."');else if(b=n.prototype.getValues.call(this,a,{volumeSeriesID:b.volumeSeriesID,period:g}))if(a=r.prototype.getValues.call(this,b,{period:f[0]}),b=r.prototype.getValues.call(this,b,{period:f[1]}),a&&b){f=f[1]-f[0];for(q=0;q<b.yData.length;q++)g=l(a.yData[q+f]-b.yData[q]),e.push([b.xData[q],g]),x.push(b.xData[q]),d.push(g);
return{values:e,xData:x,yData:d}}};b.defaultOptions=g(r.defaultOptions,{params:{index:void 0,volumeSeriesID:"volume",period:9,periods:[3,10]}});return b}(r);m(h.prototype,{nameBase:"Chaikin Osc",nameComponents:["periods"]});e.registerSeriesType("chaikin",h);"";return h});t(d,"Stock/Indicators/CMO/CMOIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&
function(c,a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&(c[b]=a[b])};return e(d,g)};return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.sma,m=e.isNumber,n=e.merge;e=function(e){function d(){var g=null!==e&&e.apply(this,arguments)||this;g.data=void 0;g.options=void 0;g.points=void 0;return g}h(d,e);d.prototype.getValues=function(g,c){var a=c.period,b=g.xData,f=g.yData;g=f?f.length:
0;var e=[],v=[],d=[],l,h=c.index;if(!(b.length<a)){m(f[0])?c=f:(h=Math.min(h,f[0].length-1),c=f.map(function(a){return a[h]}));var z=0,q=f=0;for(l=a;0<l;l--)c[l]>c[l-1]?f+=c[l]-c[l-1]:c[l]<c[l-1]&&(q+=c[l-1]-c[l]);z=0<f+q?100*(f-q)/(f+q):0;v.push(b[a]);d.push(z);e.push([b[a],z]);for(l=a+1;l<g;l++)z=Math.abs(c[l-a-1]-c[l-a]),c[l]>c[l-1]?f+=c[l]-c[l-1]:c[l]<c[l-1]&&(q+=c[l-1]-c[l]),c[l-a]>c[l-a-1]?f-=z:q-=z,z=0<f+q?100*(f-q)/(f+q):0,v.push(b[l]),d.push(z),e.push([b[l],z]);return{values:e,xData:v,yData:d}}};
d.defaultOptions=n(k.defaultOptions,{params:{period:20,index:3}});return d}(k);d.registerSeriesType("cmo",e);"";return e});t(d,"Stock/Indicators/DEMA/DEMAIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var g=function(c,a){g=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=f}||function(a,f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return g(c,a)};
return function(c,a){function b(){this.constructor=c}g(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),m=e.seriesTypes.ema,n=h.correctFloat,r=h.isArray,l=h.merge;h=function(g){function c(){var a=null!==g&&g.apply(this,arguments)||this;a.EMApercent=void 0;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(c,g);c.prototype.init=function(){var a=arguments,b=this;d.isParentLoaded(m,"ema",b.type,function(f){f.prototype.init.apply(b,a)})};c.prototype.getEMA=function(a,
b,f,c,g,e){return m.prototype.calculateEma(e||[],a,"undefined"===typeof g?1:g,this.EMApercent,b,"undefined"===typeof c?-1:c,f)};c.prototype.getValues=function(a,b){var f=b.period,c=2*f,g=a.xData,e=(a=a.yData)?a.length:0,d=-1,l=[],h=[],q=[],A=0,p=[],u;this.EMApercent=2/(f+1);if(!(e<2*f-1)){r(a[0])&&(d=b.index?b.index:0);b=m.prototype.accumulatePeriodPoints(f,d,a);var k=b/f;b=0;for(u=f;u<e+2;u++){u<e+1&&(A=this.getEMA(a,w,k,d,u)[1],p.push(A));var w=A;if(u<c)b+=A;else{u===c&&(k=b/f);A=p[u-f-1];var B=
this.getEMA([A],B,k)[1];var P=[g[u-2],n(2*A-B)];l.push(P);h.push(P[0]);q.push(P[1])}}return{values:l,xData:h,yData:q}}};c.defaultOptions=l(m.defaultOptions);return c}(m);e.registerSeriesType("dema",h);"";return h});t(d,"Stock/Indicators/TEMA/TEMAIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var g=function(c,a){g=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=
f}||function(a,f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return g(c,a)};return function(c,a){function b(){this.constructor=c}g(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),m=e.seriesTypes.ema,n=h.correctFloat,r=h.isArray,l=h.merge;h=function(g){function c(){var a=null!==g&&g.apply(this,arguments)||this;a.EMApercent=void 0;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(c,g);c.prototype.init=function(){var a=arguments,b=this;d.isParentLoaded(m,
"ema",b.type,function(f){f.prototype.init.apply(b,a)})};c.prototype.getEMA=function(a,b,f,c,g,e){return m.prototype.calculateEma(e||[],a,"undefined"===typeof g?1:g,this.EMApercent,b,"undefined"===typeof c?-1:c,f)};c.prototype.getTemaPoint=function(a,b,f,c){return[a[c-3],n(3*f.level1-3*f.level2+f.level3)]};c.prototype.getValues=function(a,b){var f=b.period,c=2*f,g=3*f,e=a.xData,d=(a=a.yData)?a.length:0,l=-1,h=[],q=[],A=[],p=[],u=[],k,n,B={};this.EMApercent=2/(f+1);if(!(d<3*f-2)){r(a[0])&&(l=b.index?
b.index:0);b=m.prototype.accumulatePeriodPoints(f,l,a);var w=b/f;b=0;for(k=f;k<d+3;k++){k<d+1&&(B.level1=this.getEMA(a,N,w,l,k)[1],p.push(B.level1));var N=B.level1;if(k<c)b+=B.level1;else{k===c&&(w=b/f,b=0);B.level1=p[k-f-1];B.level2=this.getEMA([B.level1],Q,w)[1];u.push(B.level2);var Q=B.level2;if(k<g)b+=B.level2;else{k===g&&(w=b/f);k===d+1&&(B.level1=p[k-f-1],B.level2=this.getEMA([B.level1],Q,w)[1],u.push(B.level2));B.level1=p[k-f-2];B.level2=u[k-2*f-1];B.level3=this.getEMA([B.level2],B.prevLevel3,
w)[1];if(n=this.getTemaPoint(e,g,B,k))h.push(n),q.push(n[0]),A.push(n[1]);B.prevLevel3=B.level3}}}return{values:h,xData:q,yData:A}}};c.defaultOptions=l(m.defaultOptions);return c}(m);e.registerSeriesType("tema",h);"";return h});t(d,"Stock/Indicators/TRIX/TRIXIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var e=function(g,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,
b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return e(g,c)};return function(g,c){function a(){this.constructor=g}e(g,c);g.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),m=e.seriesTypes.tema,n=h.correctFloat,r=h.merge;h=function(l){function g(){var c=null!==l&&l.apply(this,arguments)||this;c.data=void 0;c.options=void 0;c.points=void 0;return c}k(g,l);g.prototype.init=function(){var c=arguments,a=this;d.isParentLoaded(e.seriesTypes.tema,
"tema",a.type,function(b){b.prototype.init.apply(a,c)})};g.prototype.getTemaPoint=function(c,a,b,f){if(f>a)return[c[f-3],0!==b.prevLevel3?n(b.level3-b.prevLevel3)/b.prevLevel3*100:null]};g.defaultOptions=r(m.defaultOptions);return g}(m);e.registerSeriesType("trix",h);"";return h});t(d,"Stock/Indicators/APO/APOIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var g=function(c,a){g=Object.setPrototypeOf||
{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=f}||function(a,f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return g(c,a)};return function(c,a){function b(){this.constructor=c}g(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),m=e.seriesTypes.ema,n=h.extend,r=h.merge,l=h.error;h=function(g){function c(){var a=null!==g&&g.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(c,g);c.prototype.getValues=function(a,b){var f=
b.periods,c=b.index;b=[];var g=[],e=[],d;if(2!==f.length||f[1]<=f[0])l('Error: "APO requires two periods. Notice, first period should be lower than the second one."');else{var h=m.prototype.getValues.call(this,a,{index:c,period:f[0]});a=m.prototype.getValues.call(this,a,{index:c,period:f[1]});if(h&&a){f=f[1]-f[0];for(d=0;d<a.yData.length;d++)c=h.yData[d+f]-a.yData[d],b.push([a.xData[d],c]),g.push(a.xData[d]),e.push(c);return{values:b,xData:g,yData:e}}}};c.prototype.init=function(){var a=arguments,
b=this;d.isParentLoaded(m,"ema",b.type,function(f){f.prototype.init.apply(b,a)})};c.defaultOptions=r(m.defaultOptions,{params:{period:void 0,periods:[10,20]}});return c}(m);n(h.prototype,{nameBase:"APO",nameComponents:["periods"]});e.registerSeriesType("apo",h);"";return h});t(d,"Stock/Indicators/IKH/IKHIndicator.js",[d["Core/Color/Color.js"],d["Core/Globals.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h,k){function m(a){return a.reduce(function(a,b){return Math.max(a,
b[1])},-Infinity)}function n(a){return a.reduce(function(a,b){return Math.min(a,b[2])},Infinity)}function r(a){return{high:m(a),low:n(a)}}function l(a){var b,f,c,g,e;a.series.forEach(function(a){if(a.xData)for(g=a.xData,e=f=a.xIncrement?1:g.length-1;0<e;e--)if(c=g[e]-g[e-1],"undefined"===typeof b||c<b)b=c});return b}function g(a,b,f,c){if(a&&b&&f&&c){var g=b.plotX-a.plotX;b=b.plotY-a.plotY;var e=c.plotX-f.plotX;c=c.plotY-f.plotY;var d=a.plotX-f.plotX,v=a.plotY-f.plotY;f=(-b*d+g*v)/(-e*b+g*c);e=(e*
v-c*d)/(-e*b+g*c);if(0<=f&&1>=f&&0<=e&&1>=e)return{plotX:a.plotX+e*g,plotY:a.plotY+e*b}}return!1}function c(a){var b=a.indicator;b.points=a.points;b.nextPoints=a.nextPoints;b.color=a.color;b.options=C(a.options.senkouSpan.styles,a.gap);b.graph=a.graph;b.fillGraph=!0;h.seriesTypes.sma.prototype.drawGraph.call(b)}var a=this&&this.__extends||function(){var a=function(b,f){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&
(a[f]=b[f])};return a(b,f)};return function(b,f){function c(){this.constructor=b}a(b,f);b.prototype=null===f?Object.create(f):(c.prototype=f.prototype,new c)}}(),b=d.parse,f=h.seriesTypes.sma,x=k.defined;d=k.extend;var v=k.isArray,y=k.isNumber,C=k.merge,E=k.objectEach;e.approximations["ichimoku-averages"]=function(){var a=[],b;[].forEach.call(arguments,function(f,c){a.push(e.approximations.average(f));b=!b&&"undefined"===typeof a[c]});return b?void 0:a};k=function(e){function d(){var a=null!==e&&
e.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;a.graphCollection=void 0;a.graphsenkouSpan=void 0;a.ikhMap=void 0;a.nextPoints=void 0;return a}a(d,e);d.prototype.init=function(){h.seriesTypes.sma.prototype.init.apply(this,arguments);this.options=C({tenkanLine:{styles:{lineColor:this.color}},kijunLine:{styles:{lineColor:this.color}},chikouLine:{styles:{lineColor:this.color}},senkouSpanA:{styles:{lineColor:this.color,fill:b(this.color).setOpacity(.5).get()}},senkouSpanB:{styles:{lineColor:this.color,
fill:b(this.color).setOpacity(.5).get()}},senkouSpan:{styles:{fill:b(this.color).setOpacity(.2).get()}}},this.options)};d.prototype.toYData=function(a){return[a.tenkanSen,a.kijunSen,a.chikouSpan,a.senkouSpanA,a.senkouSpanB]};d.prototype.translate=function(){var a=this;h.seriesTypes.sma.prototype.translate.apply(a);a.points.forEach(function(b){a.pointArrayMap.forEach(function(f){var c=b[f];y(c)&&(b["plot"+f]=a.yAxis.toPixels(c,!0),b.plotY=b["plot"+f],b.tooltipPos=[b.plotX,b["plot"+f]],b.isNull=!1)})})};
d.prototype.drawGraph=function(){var a=this,b=a.points,f=b.length,e=a.options,d=a.graph,v=a.color,l={options:{gapSize:e.gapSize}},q=a.pointArrayMap.length,k=[[],[],[],[],[],[]],y={tenkanLine:k[0],kijunLine:k[1],chikouLine:k[2],senkouSpanA:k[3],senkouSpanB:k[4],senkouSpan:k[5]},z=[],m=a.options.senkouSpan,r=m.color||m.styles.fill,n=m.negativeColor,w=[[],[]],t=[[],[]],R=0,J,S,O;for(a.ikhMap=y;f--;){var D=b[f];for(J=0;J<q;J++)m=a.pointArrayMap[J],x(D[m])&&k[J].push({plotX:D.plotX,plotY:D["plot"+m],isNull:!1});
n&&f!==b.length-1&&(m=y.senkouSpanB.length-1,D=g(y.senkouSpanA[m-1],y.senkouSpanA[m],y.senkouSpanB[m-1],y.senkouSpanB[m]),J={plotX:D.plotX,plotY:D.plotY,isNull:!1,intersectPoint:!0},D&&(y.senkouSpanA.splice(m,0,J),y.senkouSpanB.splice(m,0,J),z.push(m)))}E(y,function(b,f){e[f]&&"senkouSpan"!==f&&(a.points=k[R],a.options=C(e[f].styles,l),a.graph=a["graph"+f],a.fillGraph=!1,a.color=v,h.seriesTypes.sma.prototype.drawGraph.call(a),a["graph"+f]=a.graph);R++});a.graphCollection&&a.graphCollection.forEach(function(b){a[b].destroy();
delete a[b]});a.graphCollection=[];if(n&&y.senkouSpanA[0]&&y.senkouSpanB[0]){z.unshift(0);z.push(y.senkouSpanA.length-1);for(q=0;q<z.length-1;q++){m=z[q];D=z[q+1];f=y.senkouSpanB.slice(m,D+1);m=y.senkouSpanA.slice(m,D+1);if(1<=Math.floor(f.length/2))if(D=Math.floor(f.length/2),f[D].plotY===m[D].plotY){for(O=J=D=0;O<f.length;O++)D+=f[O].plotY,J+=m[O].plotY;D=D>J?0:1}else D=f[D].plotY>m[D].plotY?0:1;else D=f[0].plotY>m[0].plotY?0:1;w[D]=w[D].concat(f);t[D]=t[D].concat(m)}["graphsenkouSpanColor","graphsenkouSpanNegativeColor"].forEach(function(b,
f){w[f].length&&t[f].length&&(S=0===f?r:n,c({indicator:a,points:w[f],nextPoints:t[f],color:S,options:e,gap:l,graph:a[b]}),a[b]=a.graph,a.graphCollection.push(b))})}else c({indicator:a,points:y.senkouSpanB,nextPoints:y.senkouSpanA,color:r,options:e,gap:l,graph:a.graphsenkouSpan}),a.graphsenkouSpan=a.graph;delete a.nextPoints;delete a.fillGraph;a.points=b;a.options=e;a.graph=d;a.color=v};d.prototype.getGraphPath=function(a){var b=[],f;a=a||this.points;if(this.fillGraph&&this.nextPoints){if((f=h.seriesTypes.sma.prototype.getGraphPath.call(this,
this.nextPoints))&&f.length){f[0][0]="L";b=h.seriesTypes.sma.prototype.getGraphPath.call(this,a);f=f.slice(0,b.length);for(var c=f.length-1;0<=c;c--)b.push(f[c])}}else b=h.seriesTypes.sma.prototype.getGraphPath.apply(this,arguments);return b};d.prototype.getValues=function(a,b){var f=b.period,c=b.periodTenkan;b=b.periodSenkouSpanB;var g=a.xData,e=a.yData,d=e&&e.length||0;a=l(a.xAxis);var x=[],h=[],p;if(!(g.length<=f)&&v(e[0])&&4===e[0].length){var q=g[0]-f*a;for(p=0;p<f;p++)h.push(q+p*a);for(p=0;p<
d;p++){if(p>=c){var k=e.slice(p-c,p);k=r(k);k=(k.high+k.low)/2}if(p>=f){var y=e.slice(p-f,p);y=r(y);y=(y.high+y.low)/2;var z=(k+y)/2}if(p>=b){var C=e.slice(p-b,p);C=r(C);C=(C.high+C.low)/2}q=e[p][3];var m=g[p];"undefined"===typeof x[p]&&(x[p]=[]);"undefined"===typeof x[p+f]&&(x[p+f]=[]);x[p+f][0]=k;x[p+f][1]=y;x[p+f][2]=void 0;x[p][2]=q;p<=f&&(x[p+f][3]=void 0,x[p+f][4]=void 0);"undefined"===typeof x[p+2*f]&&(x[p+2*f]=[]);x[p+2*f][3]=z;x[p+2*f][4]=C;h.push(m)}for(p=1;p<=f;p++)h.push(m+p*a);return{values:x,
xData:h,yData:x}}};d.defaultOptions=C(f.defaultOptions,{params:{index:void 0,period:26,periodTenkan:9,periodSenkouSpanB:52},marker:{enabled:!1},tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span> <b> {series.name}</b><br/>TENKAN SEN: {point.tenkanSen:.3f}<br/>KIJUN SEN: {point.kijunSen:.3f}<br/>CHIKOU SPAN: {point.chikouSpan:.3f}<br/>SENKOU SPAN A: {point.senkouSpanA:.3f}<br/>SENKOU SPAN B: {point.senkouSpanB:.3f}<br/>'},tenkanLine:{styles:{lineWidth:1,lineColor:void 0}},kijunLine:{styles:{lineWidth:1,
lineColor:void 0}},chikouLine:{styles:{lineWidth:1,lineColor:void 0}},senkouSpanA:{styles:{lineWidth:1,lineColor:void 0}},senkouSpanB:{styles:{lineWidth:1,lineColor:void 0}},senkouSpan:{styles:{fill:"rgba(255, 0, 0, 0.5)"}},dataGrouping:{approximation:"ichimoku-averages"}});return d}(f);d(k.prototype,{pointArrayMap:["tenkanSen","kijunSen","chikouSpan","senkouSpanA","senkouSpanB"],pointValKey:"tenkanSen",nameComponents:["periodSenkouSpanB","period","periodTenkan"]});h.registerSeriesType("ikh",k);"";
return k});t(d,"Stock/Indicators/KeltnerChannels/KeltnerChannelsIndicator.js",[d["Mixins/MultipleLines.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var g=function(c,a){g=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=f}||function(a,f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return g(c,a)};return function(c,a){function b(){this.constructor=c}g(c,a);c.prototype=null===a?Object.create(a):
(b.prototype=a.prototype,new b)}}(),m=e.seriesTypes.sma,n=h.correctFloat,r=h.extend,l=h.merge;h=function(g){function c(){var a=null!==g&&g.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(c,g);c.prototype.init=function(){e.seriesTypes.sma.prototype.init.apply(this,arguments);this.options=l({topLine:{styles:{lineColor:this.color}},bottomLine:{styles:{lineColor:this.color}}},this.options)};c.prototype.getValues=function(a,b){var f=b.period,c=b.periodATR,g=b.multiplierATR,
d=a.yData;d=d?d.length:0;var l=[];b=e.seriesTypes.ema.prototype.getValues(a,{period:f,index:b.index});var h=e.seriesTypes.atr.prototype.getValues(a,{period:c}),k=[],q=[],m;if(!(d<f)){for(m=f;m<=d;m++){var p=b.values[m-f];var u=h.values[m-c];var r=p[0];a=n(p[1]+g*u[1]);u=n(p[1]-g*u[1]);p=p[1];l.push([r,a,p,u]);k.push(r);q.push([a,p,u])}return{values:l,xData:k,yData:q}}};c.defaultOptions=l(m.defaultOptions,{params:{period:20,periodATR:10,multiplierATR:2},bottomLine:{styles:{lineWidth:1,lineColor:void 0}},
topLine:{styles:{lineWidth:1,lineColor:void 0}},tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span><b> {series.name}</b><br/>Upper Channel: {point.top}<br/>EMA({series.options.params.period}): {point.middle}<br/>Lower Channel: {point.bottom}<br/>'},marker:{enabled:!1},dataGrouping:{approximation:"averages"},lineWidth:1});return c}(m);r(h.prototype,{pointArrayMap:["top","middle","bottom"],pointValKey:"middle",nameBase:"Keltner Channels",nameComponents:["period","periodATR","multiplierATR"],
linesApiNames:["topLine","bottomLine"],requiredIndicators:["ema","atr"],drawGraph:d.drawGraph,getTranslatedLinesNames:d.getTranslatedLinesNames,translate:d.translate,toYData:d.toYData});e.registerSeriesType("keltnerchannels",h);"";return h});t(d,"Stock/Indicators/Klinger/KlingerIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Mixins/MultipleLines.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h,k){var m=this&&this.__extends||function(){var a=function(b,f){a=Object.setPrototypeOf||
{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return a(b,f)};return function(b,f){function c(){this.constructor=b}a(b,f);b.prototype=null===f?Object.create(f):(c.prototype=f.prototype,new c)}}(),n=h.seriesTypes,r=n.sma,l=n.ema,g=k.correctFloat,c=k.error;n=k.extend;var a=k.isArray,b=k.merge;k=function(f){function e(){var a=null!==f&&f.apply(this,arguments)||this;a.data=void 0;a.points=void 0;a.options=void 0;a.volumeSeries=
void 0;return a}m(e,f);e.prototype.init=function(){var a=arguments,b=this;d.isParentLoaded(l,"ema",b.type,function(f){f.prototype.init.apply(b,a)})};e.prototype.calculateTrend=function(a,b){return a[b][1]+a[b][2]+a[b][3]>a[b-1][1]+a[b-1][2]+a[b-1][3]?1:-1};e.prototype.isValidData=function(b){var f=this.chart,g=this.options,e=this.linkedParent;b=a(b)&&4===b.length;(f=this.volumeSeries||(this.volumeSeries=f.get(g.params.volumeSeriesID)))||c("Series "+g.params.volumeSeriesID+" not found! Check `volumeSeriesID`.",
!0,e.chart);return!(![e,f].every(function(a){return a&&a.xData&&a.xData.length>=g.params.slowAvgPeriod})||!b)};e.prototype.getCM=function(a,b,f,c,e){return g(b+(f===c?a:e))};e.prototype.getDM=function(a,b){return g(a-b)};e.prototype.getVolumeForce=function(a){var b=[],f=1;var c=0;var g=a[0][1]-a[0][2];var e=0;for(f;f<a.length;f++){var d=this.calculateTrend(a,f);var l=this.getDM(a[f][1],a[f][2]);c=this.getCM(c,l,d,e,g);e=this.volumeSeries.yData[f]*d*Math.abs(2*(l/c-1))*100;b.push([e]);e=d;g=l}return b};
e.prototype.getEMA=function(a,b,f,c,g,e,d){return l.prototype.calculateEma(d||[],a,"undefined"===typeof e?1:e,c,b,"undefined"===typeof g?-1:g,f)};e.prototype.getSMA=function(a,b,f){return l.prototype.accumulatePeriodPoints(a,b,f)/a};e.prototype.getValues=function(a,b){var f=[],c=a.xData;a=a.yData;var e=[],d=[],l=[],x,h=0,v=0,k=void 0,m=void 0,y=null;if(this.isValidData(a[0])){var r=this.getVolumeForce(a),n=this.getSMA(b.fastAvgPeriod,0,r),w=this.getSMA(b.slowAvgPeriod,0,r),t=2/(b.fastAvgPeriod+1),
F=2/(b.slowAvgPeriod+1);for(h;h<a.length;h++)h>=b.fastAvgPeriod&&(k=v=this.getEMA(r,k,n,t,0,h,c)[1]),h>=b.slowAvgPeriod&&(m=x=this.getEMA(r,m,w,F,0,h,c)[1],x=g(v-x),l.push(x),l.length>=b.signalPeriod&&(y=l.slice(-b.signalPeriod).reduce(function(a,b){return a+b})/b.signalPeriod),f.push([c[h],x,y]),e.push(c[h]),d.push([x,y]));return{values:f,xData:e,yData:d}}};e.defaultOptions=b(r.defaultOptions,{params:{fastAvgPeriod:34,slowAvgPeriod:55,signalPeriod:13,volumeSeriesID:"volume"},signalLine:{styles:{lineWidth:1,
lineColor:"#ff0000"}},dataGrouping:{approximation:"averages"},tooltip:{pointFormat:'<span style="color: {point.color}">\u25cf</span><b> {series.name}</b><br/><span style="color: {point.color}">Klinger</span>: {point.y}<br/><span style="color: {point.series.options.signalLine.styles.lineColor}">Signal</span>: {point.signal}<br/>'}});return e}(r);n(k.prototype,{linesApiNames:["signalLine"],nameBase:"Klinger",nameComponents:["fastAvgPeriod","slowAvgPeriod"],pointArrayMap:["y","signal"],parallelArrays:["x",
"y","signal"],pointValKey:"y",drawGraph:e.drawGraph,getTranslatedLinesNames:e.getTranslatedLinesNames,translate:e.translate,toYData:e.toYData});h.registerSeriesType("klinger",k);"";return k});t(d,"Stock/Indicators/MACD/MACDIndicator.js",[d["Core/Globals.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var a=function(b,f){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&
(a[f]=b[f])};return a(b,f)};return function(b,f){function c(){this.constructor=b}a(b,f);b.prototype=null===f?Object.create(f):(c.prototype=f.prototype,new c)}}(),m=d.noop,n=e.seriesTypes.sma,r=h.extend,l=h.correctFloat,g=h.defined,c=h.merge;h=function(a){function b(){var b=null!==a&&a.apply(this,arguments)||this;b.data=void 0;b.options=void 0;b.points=void 0;b.currentLineZone=void 0;b.graphmacd=void 0;b.graphsignal=void 0;b.macdZones=void 0;b.signalZones=void 0;return b}k(b,a);b.prototype.init=function(){e.seriesTypes.sma.prototype.init.apply(this,
arguments);this.options&&(this.options=c({signalLine:{styles:{lineColor:this.color}},macdLine:{styles:{color:this.color}}},this.options),this.macdZones={zones:this.options.macdLine.zones,startIndex:0},this.signalZones={zones:this.macdZones.zones.concat(this.options.signalLine.zones),startIndex:this.macdZones.zones.length},this.resetZones=!0)};b.prototype.toYData=function(a){return[a.y,a.signal,a.MACD]};b.prototype.translate=function(){var a=this,b=["plotSignal","plotMACD"];d.seriesTypes.column.prototype.translate.apply(a);
a.points.forEach(function(f){[f.signal,f.MACD].forEach(function(c,g){null!==c&&(f[b[g]]=a.yAxis.toPixels(c,!0))})})};b.prototype.destroy=function(){this.graph=null;this.graphmacd=this.graphmacd&&this.graphmacd.destroy();this.graphsignal=this.graphsignal&&this.graphsignal.destroy();e.seriesTypes.sma.prototype.destroy.apply(this,arguments)};b.prototype.drawGraph=function(){for(var a=this,b=a.points,d=b.length,l=a.options,h=a.zones,k={options:{gapSize:l.gapSize}},z=[[],[]],q;d--;)q=b[d],g(q.plotMACD)&&
z[0].push({plotX:q.plotX,plotY:q.plotMACD,isNull:!g(q.plotMACD)}),g(q.plotSignal)&&z[1].push({plotX:q.plotX,plotY:q.plotSignal,isNull:!g(q.plotMACD)});["macd","signal"].forEach(function(b,f){a.points=z[f];a.options=c(l[b+"Line"].styles,k);a.graph=a["graph"+b];a.currentLineZone=b+"Zones";a.zones=a[a.currentLineZone].zones;e.seriesTypes.sma.prototype.drawGraph.call(a);a["graph"+b]=a.graph});a.points=b;a.options=l;a.zones=h;a.currentLineZone=null};b.prototype.getZonesGraphs=function(b){var f=a.prototype.getZonesGraphs.call(this,
b),c=f;this.currentLineZone&&(c=f.splice(this[this.currentLineZone].startIndex+1),c.length?c.splice(0,0,b[0]):c=[b[0]]);return c};b.prototype.applyZones=function(){var a=this.zones;this.zones=this.signalZones.zones;e.seriesTypes.sma.prototype.applyZones.call(this);this.graphmacd&&this.options.macdLine.zones.length&&this.graphmacd.hide();this.zones=a};b.prototype.getValues=function(a,b){var f=b.longPeriod-b.shortPeriod,c=0,d=[],h=[],x=[];if(!(a.xData.length<b.longPeriod+b.signalPeriod)){var k=e.seriesTypes.ema.prototype.getValues(a,
{period:b.shortPeriod,index:b.index});var m=e.seriesTypes.ema.prototype.getValues(a,{period:b.longPeriod,index:b.index});k=k.values;m=m.values;for(a=0;a<=k.length;a++)g(m[a])&&g(m[a][1])&&g(k[a+f])&&g(k[a+f][0])&&d.push([k[a+f][0],0,null,k[a+f][1]-m[a][1]]);for(a=0;a<d.length;a++)h.push(d[a][0]),x.push([0,null,d[a][3]]);b=e.seriesTypes.ema.prototype.getValues({xData:h,yData:x},{period:b.signalPeriod,index:2});b=b.values;for(a=0;a<d.length;a++)d[a][0]>=b[0][0]&&(d[a][2]=b[c][1],x[a]=[0,b[c][1],d[a][3]],
null===d[a][3]?(d[a][1]=0,x[a][0]=0):(d[a][1]=l(d[a][3]-b[c][1]),x[a][0]=l(d[a][3]-b[c][1])),c++);return{values:d,xData:h,yData:x}}};b.defaultOptions=c(n.defaultOptions,{params:{shortPeriod:12,longPeriod:26,signalPeriod:9,period:26},signalLine:{zones:[],styles:{lineWidth:1,lineColor:void 0}},macdLine:{zones:[],styles:{lineWidth:1,lineColor:void 0}},threshold:0,groupPadding:.1,pointPadding:.1,crisp:!1,states:{hover:{halo:{size:0}}},tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span> <b> {series.name}</b><br/>Value: {point.MACD}<br/>Signal: {point.signal}<br/>Histogram: {point.y}<br/>'},
dataGrouping:{approximation:"averages"},minPointLength:0});return b}(n);r(h.prototype,{nameComponents:["longPeriod","shortPeriod","signalPeriod"],requiredIndicators:["ema"],pointArrayMap:["y","signal","MACD"],parallelArrays:["x","y","signal","MACD"],pointValKey:"y",markerAttribs:m,getColumnMetrics:d.seriesTypes.column.prototype.getColumnMetrics,crispCol:d.seriesTypes.column.prototype.crispCol,drawPoints:d.seriesTypes.column.prototype.drawPoints});e.registerSeriesType("macd",h);"";return h});t(d,"Stock/Indicators/MFI/MFIIndicator.js",
[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){function h(a){return a.reduce(function(a,f){return a+f})}function k(a){return(a[1]+a[2]+a[3])/3}var m=this&&this.__extends||function(){var a=function(b,f){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return a(b,f)};return function(b,f){function c(){this.constructor=b}a(b,f);b.prototype=null===f?Object.create(f):(c.prototype=
f.prototype,new c)}}(),n=d.seriesTypes.sma,r=e.extend,l=e.merge,g=e.error,c=e.isArray;e=function(a){function b(){var b=null!==a&&a.apply(this,arguments)||this;b.data=void 0;b.options=void 0;b.points=void 0;return b}m(b,a);b.prototype.getValues=function(a,b){var f=b.period,e=a.xData,d=a.yData,l=d?d.length:0,x=b.decimals,q=1,m=a.chart.get(b.volumeSeriesID),p=m&&m.yData,u=[],r=[],n=[],w=[],t=[];if(!m)g("Series "+b.volumeSeriesID+" not found! Check `volumeSeriesID`.",!0,a.chart);else if(!(e.length<=f)&&
c(d[0])&&4===d[0].length&&p){for(a=k(d[q]);q<f+1;)b=a,a=k(d[q]),b=a>=b,m=a*p[q],w.push(b?m:0),t.push(b?0:m),q++;for(f=q-1;f<l;f++)f>q-1&&(w.shift(),t.shift(),b=a,a=k(d[f]),b=a>b,m=a*p[f],w.push(b?m:0),t.push(b?0:m)),b=h(t),m=h(w),b=m/b,b=parseFloat((100-100/(1+b)).toFixed(x)),u.push([e[f],b]),r.push(e[f]),n.push(b);return{values:u,xData:r,yData:n}}};b.defaultOptions=l(n.defaultOptions,{params:{index:void 0,volumeSeriesID:"volume",decimals:4}});return b}(n);r(e.prototype,{nameBase:"Money Flow Index"});
d.registerSeriesType("mfi",e);"";return e});t(d,"Stock/Indicators/Momentum/MomentumIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(g,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return e(g,c)};return function(g,c){function a(){this.constructor=g}e(g,c);g.prototype=null===c?Object.create(c):(a.prototype=
c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.extend,n=e.isArray,r=e.merge;e=function(e){function g(){var c=null!==e&&e.apply(this,arguments)||this;c.data=void 0;c.options=void 0;c.points=void 0;return c}h(g,e);g.prototype.getValues=function(c,a){var b=a.period;a=a.index;var f=c.xData,g=(c=c.yData)?c.length:0,e=[],d=[],l=[],h;if(!(f.length<=b)&&n(c[0])){for(h=b+1;h<g;h++){var k=[f[h-1],c[h-1][a]-c[h-b-1][a]];e.push(k);d.push(k[0]);l.push(k[1])}k=[f[h-1],c[h-1][a]-c[h-b-1][a]];e.push(k);d.push(k[0]);
l.push(k[1]);return{values:e,xData:d,yData:l}}};g.defaultOptions=r(k.defaultOptions,{params:{index:3}});return g}(k);m(e.prototype,{nameBase:"Momentum"});d.registerSeriesType("momentum",e);"";return e});t(d,"Stock/Indicators/NATR/NATRIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(c,a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&
(c[b]=a[b])};return e(d,g)};return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.atr,m=e.merge;e=e.extend;var n=function(e){function d(){var g=null!==e&&e.apply(this,arguments)||this;g.data=void 0;g.points=void 0;g.options=void 0;return g}h(d,e);d.prototype.getValues=function(g,c){var a=k.prototype.getValues.apply(this,arguments),b=a.values.length,f=c.period-1,e=g.yData,d=0;if(a){for(;d<b;d++)a.yData[d]=
a.values[d][1]/e[f][3]*100,a.values[d][1]=a.yData[d],f++;return a}};d.defaultOptions=m(k.defaultOptions,{tooltip:{valueSuffix:"%"}});return d}(k);e(n.prototype,{requiredIndicators:["atr"]});d.registerSeriesType("natr",n);"";return n});t(d,"Stock/Indicators/OBV/OBVIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var g=function(c,a){g=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,f){a.__proto__=f}||function(a,
f){for(var b in f)f.hasOwnProperty(b)&&(a[b]=f[b])};return g(c,a)};return function(c,a){function b(){this.constructor=c}g(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),k=d.seriesTypes.sma,m=e.isNumber,n=e.error,r=e.extend,l=e.merge;e=function(g){function c(){var a=null!==g&&g.apply(this,arguments)||this;a.data=void 0;a.points=void 0;a.options=void 0;return a}h(c,g);c.prototype.getValues=function(a,b){var f=a.chart.get(b.volumeSeriesID),c=a.xData,g=a.yData,e=[],d=[],
h=[],l=!m(g[0]),k=1,r=0;if(f){f=f.yData;a=[c[0],r];var p=l?g[0][3]:g[0];e.push(a);d.push(c[0]);h.push(a[1]);for(k;k<g.length;k++)b=l?g[k][3]:g[k],r=b>p?r+f[k]:b===p?r:r-f[k],a=[c[k],r],p=b,e.push(a),d.push(c[k]),h.push(a[1]);return{values:e,xData:d,yData:h}}n("Series "+b.volumeSeriesID+" not found! Check `volumeSeriesID`.",!0,a.chart)};c.defaultOptions=l(k.defaultOptions,{marker:{enabled:!1},params:{index:void 0,period:void 0,volumeSeriesID:"volume"},tooltip:{valueDecimals:0}});return c}(k);r(e.prototype,
{nameComponents:void 0});d.registerSeriesType("obv",e);"";return e});t(d,"Stock/Indicators/PivotPoints/PivotPointsPoint.js",[d["Core/Series/SeriesRegistry.js"]],function(d){function e(e,h){var k=e.series.pointArrayMap,m=k.length;for(d.seriesTypes.sma.prototype.pointClass.prototype[h].call(e);m--;)h="dataLabel"+k[m],e[h]&&e[h].element&&e[h].destroy(),e[h]=null}var h=this&&this.__extends||function(){var e=function(d,h){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,d){e.__proto__=
d}||function(e,d){for(var g in d)d.hasOwnProperty(g)&&(e[g]=d[g])};return e(d,h)};return function(d,h){function k(){this.constructor=d}e(d,h);d.prototype=null===h?Object.create(h):(k.prototype=h.prototype,new k)}}();return function(d){function k(){var e=null!==d&&d.apply(this,arguments)||this;e.P=void 0;e.pivotLine=void 0;e.series=void 0;return e}h(k,d);k.prototype.destroyElements=function(){e(this,"destroyElements")};k.prototype.destroy=function(){e(this,"destroyElements")};return k}(d.seriesTypes.sma.prototype.pointClass)});
t(d,"Stock/Indicators/PivotPoints/PivotPointsIndicator.js",[d["Stock/Indicators/PivotPoints/PivotPointsPoint.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var c=function(a,b){c=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var f in b)b.hasOwnProperty(f)&&(a[f]=b[f])};return c(a,b)};return function(a,b){function f(){this.constructor=a}c(a,b);a.prototype=null===b?Object.create(b):
(f.prototype=b.prototype,new f)}}(),m=e.seriesTypes.sma,n=h.merge,r=h.extend,l=h.defined,g=h.isArray;h=function(c){function a(){var a=null!==c&&c.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;a.endPoint=void 0;a.plotEndPoint=void 0;return a}k(a,c);a.prototype.toYData=function(a){return[a.P]};a.prototype.translate=function(){var a=this;e.seriesTypes.sma.prototype.translate.apply(a);a.points.forEach(function(b){a.pointArrayMap.forEach(function(f){l(b[f])&&(b["plot"+f]=a.yAxis.toPixels(b[f],
!0))})});a.plotEndPoint=a.xAxis.toPixels(a.endPoint,!0)};a.prototype.getGraphPath=function(a){for(var b=this,c=a.length,g=[[],[],[],[],[],[],[],[],[]],d=[],h=b.plotEndPoint,k=b.pointArrayMap.length,m,q,r;c--;){q=a[c];for(r=0;r<k;r++)m=b.pointArrayMap[r],l(q[m])&&g[r].push({plotX:q.plotX,plotY:q["plot"+m],isNull:!1},{plotX:h,plotY:q["plot"+m],isNull:!1},{plotX:h,plotY:null,isNull:!0});h=q.plotX}g.forEach(function(a){d=d.concat(e.seriesTypes.sma.prototype.getGraphPath.call(b,a))});return d};a.prototype.drawDataLabels=
function(){var a=this,f=a.pointArrayMap,c,g,d;if(a.options.dataLabels.enabled){var h=a.points.length;f.concat([!1]).forEach(function(b,l){for(d=h;d--;)g=a.points[d],b?(g.y=g[b],g.pivotLine=b,g.plotY=g["plot"+b],c=g["dataLabel"+b],l&&(g["dataLabel"+f[l-1]]=g.dataLabel),g.dataLabels||(g.dataLabels=[]),g.dataLabels[0]=g.dataLabel=c=c&&c.element?c:null):g["dataLabel"+f[l-1]]=g.dataLabel;e.seriesTypes.sma.prototype.drawDataLabels.apply(a,arguments)})}};a.prototype.getValues=function(a,f){var b=f.period,
c=a.xData,e=(a=a.yData)?a.length:0;f=this[f.algorithm+"Placement"];var d=[],h=[],l=[],k;if(!(c.length<b)&&g(a[0])&&4===a[0].length){for(k=b+1;k<=e+b;k+=b){var m=c.slice(k-b-1,k);var p=a.slice(k-b-1,k);var u=m.length;var r=m[u-1];p=this.getPivotAndHLC(p);p=f(p);p=d.push([r].concat(p));h.push(r);l.push(d[p-1].slice(1))}this.endPoint=m[0]+(r-m[0])/u*b;return{values:d,xData:h,yData:l}}};a.prototype.getPivotAndHLC=function(a){var b=-Infinity,c=Infinity,g=a[a.length-1][3];a.forEach(function(a){b=Math.max(b,
a[1]);c=Math.min(c,a[2])});return[(b+c+g)/3,b,c,g]};a.prototype.standardPlacement=function(a){var b=a[1]-a[2];return[null,null,a[0]+b,2*a[0]-a[2],a[0],2*a[0]-a[1],a[0]-b,null,null]};a.prototype.camarillaPlacement=function(a){var b=a[1]-a[2];return[a[3]+1.5*b,a[3]+1.25*b,a[3]+1.1666*b,a[3]+1.0833*b,a[0],a[3]-1.0833*b,a[3]-1.1666*b,a[3]-1.25*b,a[3]-1.5*b]};a.prototype.fibonacciPlacement=function(a){var b=a[1]-a[2];return[null,a[0]+b,a[0]+.618*b,a[0]+.382*b,a[0],a[0]-.382*b,a[0]-.618*b,a[0]-b,null]};
a.defaultOptions=n(m.defaultOptions,{params:{index:void 0,period:28,algorithm:"standard"},marker:{enabled:!1},enableMouseTracking:!1,dataLabels:{enabled:!0,format:"{point.pivotLine}"},dataGrouping:{approximation:"averages"}});return a}(m);r(h.prototype,{nameBase:"Pivot Points",pointArrayMap:"R4 R3 R2 R1 P S1 S2 S3 S4".split(" "),pointValKey:"P",pointClass:d});e.registerSeriesType("pivotpoints",h);"";return h});t(d,"Stock/Indicators/PPO/PPOIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],
d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var c=function(a,b){c=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return c(a,b)};return function(a,b){function f(){this.constructor=a}c(a,b);a.prototype=null===b?Object.create(b):(f.prototype=b.prototype,new f)}}(),m=e.seriesTypes.ema,n=h.correctFloat,r=h.extend,l=h.merge,g=h.error;h=function(c){function a(){var a=null!==
c&&c.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(a,c);a.prototype.init=function(){var a=arguments,c=this;d.isParentLoaded(m,"ema",c.type,function(b){b.prototype.init.apply(c,a)})};a.prototype.getValues=function(a,c){var b=c.periods,f=c.index;c=[];var e=[],d=[],h;if(2!==b.length||b[1]<=b[0])g('Error: "PPO requires two periods. Notice, first period should be lower than the second one."');else{var l=m.prototype.getValues.call(this,a,{index:f,period:b[0]});a=
m.prototype.getValues.call(this,a,{index:f,period:b[1]});if(l&&a){b=b[1]-b[0];for(h=0;h<a.yData.length;h++)f=n((l.yData[h+b]-a.yData[h])/a.yData[h]*100),c.push([a.xData[h],f]),e.push(a.xData[h]),d.push(f);return{values:c,xData:e,yData:d}}}};a.defaultOptions=l(m.defaultOptions,{params:{period:void 0,periods:[12,26]}});return a}(m);r(h.prototype,{nameBase:"PPO",nameComponents:["periods"]});e.registerSeriesType("ppo",h);"";return h});t(d,"Mixins/ReduceArray.js",[],function(){return{minInArray:function(d,
e){return d.reduce(function(d,k){return Math.min(d,k[e])},Number.MAX_VALUE)},maxInArray:function(d,e){return d.reduce(function(d,k){return Math.max(d,k[e])},-Number.MAX_VALUE)},getArrayExtremes:function(d,e,h){return d.reduce(function(d,m){return[Math.min(d[0],m[e]),Math.max(d[1],m[h])]},[Number.MAX_VALUE,-Number.MAX_VALUE])}}});t(d,"Stock/Indicators/PC/PCIndicator.js",[d["Core/Color/Palette.js"],d["Mixins/MultipleLines.js"],d["Mixins/ReduceArray.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],
function(d,e,h,k,m){var n=this&&this.__extends||function(){var c=function(a,b){c=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return c(a,b)};return function(a,b){function f(){this.constructor=a}c(a,b);a.prototype=null===b?Object.create(b):(f.prototype=b.prototype,new f)}}(),r=k.seriesTypes.sma,l=m.merge;m=m.extend;var g=h.getArrayExtremes;h=function(c){function a(){var a=null!==c&&c.apply(this,arguments)||
this;a.data=void 0;a.options=void 0;a.points=void 0;return a}n(a,c);a.prototype.getValues=function(a,c){c=c.period;var b=a.xData,f=(a=a.yData)?a.length:0,e=[],d=[],h=[],l;if(!(f<c)){for(l=c;l<=f;l++){var k=b[l-1];var m=a.slice(l-c,l);var p=g(m,2,1);m=p[1];var r=p[0];p=(m+r)/2;e.push([k,m,p,r]);d.push(k);h.push([m,p,r])}return{values:e,xData:d,yData:h}}};a.defaultOptions=l(r.defaultOptions,{params:{index:void 0,period:20},lineWidth:1,topLine:{styles:{lineColor:d.colors[2],lineWidth:1}},bottomLine:{styles:{lineColor:d.colors[8],
lineWidth:1}},dataGrouping:{approximation:"averages"}});return a}(r);m(h.prototype,{getTranslatedLinesNames:e.getTranslatedLinesNames,drawGraph:e.drawGraph,toYData:e.toYData,pointArrayMap:["top","middle","bottom"],pointValKey:"middle",nameBase:"Price Channel",nameComponents:["period"],linesApiNames:["topLine","bottomLine"],translate:e.translate});k.registerSeriesType("pc",h);"";return h});t(d,"Stock/Indicators/PriceEnvelopes/PriceEnvelopesIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],
function(d,e){var h=this&&this.__extends||function(){var e=function(g,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return e(g,c)};return function(g,c){function a(){this.constructor=g}e(g,c);g.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.extend,n=e.isArray,r=e.merge;e=function(e){function g(){var c=null!==e&&e.apply(this,arguments)||this;c.data=
void 0;c.options=void 0;c.points=void 0;return c}h(g,e);g.prototype.init=function(){d.seriesTypes.sma.prototype.init.apply(this,arguments);this.options=r({topLine:{styles:{lineColor:this.color}},bottomLine:{styles:{lineColor:this.color}}},this.options)};g.prototype.toYData=function(c){return[c.top,c.middle,c.bottom]};g.prototype.translate=function(){var c=this,a=["plotTop","plotMiddle","plotBottom"];d.seriesTypes.sma.prototype.translate.apply(c);c.points.forEach(function(b){[b.top,b.middle,b.bottom].forEach(function(f,
g){null!==f&&(b[a[g]]=c.yAxis.toPixels(f,!0))})})};g.prototype.drawGraph=function(){for(var c=this,a=c.points,b=a.length,f=c.options,g=c.graph,e={options:{gapSize:f.gapSize}},h=[[],[]],l;b--;)l=a[b],h[0].push({plotX:l.plotX,plotY:l.plotTop,isNull:l.isNull}),h[1].push({plotX:l.plotX,plotY:l.plotBottom,isNull:l.isNull});["topLine","bottomLine"].forEach(function(a,b){c.points=h[b];c.options=r(f[a].styles,e);c.graph=c["graph"+a];d.seriesTypes.sma.prototype.drawGraph.call(c);c["graph"+a]=c.graph});c.points=
a;c.options=f;c.graph=g;d.seriesTypes.sma.prototype.drawGraph.call(c)};g.prototype.getValues=function(c,a){var b=a.period,f=a.topBand,g=a.bottomBand,e=c.xData,h=(c=c.yData)?c.length:0,l=[],k=[],m=[],q;if(!(e.length<b)&&n(c[0])&&4===c[0].length){for(q=b;q<=h;q++){var r=e.slice(q-b,q);var p=c.slice(q-b,q);p=d.seriesTypes.sma.prototype.getValues.call(this,{xData:r,yData:p},a);r=p.xData[0];p=p.yData[0];var u=p*(1+f);var w=p*(1-g);l.push([r,u,p,w]);k.push(r);m.push([u,p,w])}return{values:l,xData:k,yData:m}}};
g.defaultOptions=r(k.defaultOptions,{marker:{enabled:!1},tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span><b> {series.name}</b><br/>Top: {point.top}<br/>Middle: {point.middle}<br/>Bottom: {point.bottom}<br/>'},params:{period:20,topBand:.1,bottomBand:.1},bottomLine:{styles:{lineWidth:1,lineColor:void 0}},topLine:{styles:{lineWidth:1}},dataGrouping:{approximation:"averages"}});return g}(k);m(e.prototype,{nameComponents:["period","topBand","bottomBand"],nameBase:"Price envelopes",
pointArrayMap:["top","middle","bottom"],parallelArrays:["x","y","top","bottom"],pointValKey:"middle"});d.registerSeriesType("priceenvelopes",e);"";return e});t(d,"Stock/Indicators/PSAR/PSARIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(c,a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&(c[b]=a[b])};return e(d,g)};
return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.sma,m=e.merge;e=e.extend;var n=function(e){function d(){var g=null!==e&&e.apply(this,arguments)||this;g.data=void 0;g.points=void 0;g.options=void 0;return g}h(d,e);d.prototype.getValues=function(g,c){var a=g.xData;g=g.yData;var b=g[0][1],f=c.maxAccelerationFactor,e=c.increment,d=c.initialAccelerationFactor,h=g[0][2],l=c.decimals,k=c.index,m=[],q=[],
r=[],p=1,u;if(!(k>=g.length)){for(u=0;u<k;u++)b=Math.max(g[u][1],b),h=Math.min(g[u][2],parseFloat(h.toFixed(l)));var n=g[u][1]>h?1:-1;c=c.initialAccelerationFactor;var K=c*(b-h);m.push([a[k],h]);q.push(a[k]);r.push(parseFloat(h.toFixed(l)));for(u=k+1;u<g.length;u++){k=g[u-1][2];var B=g[u-2][2];var w=g[u-1][1];var N=g[u-2][1];var t=g[u][1];var L=g[u][2];null!==B&&null!==N&&null!==k&&null!==w&&null!==t&&null!==L&&(h=n===p?1===n?h+K<Math.min(B,k)?h+K:Math.min(B,k):h+K>Math.max(N,w)?h+K:Math.max(N,w):
b,k=1===n?t>b?t:b:L<b?L:b,t=1===p&&L>h||-1===p&&t>h?1:-1,p=t,K=k,L=e,B=f,w=d,c=p===n?1===p&&K>b?c===B?B:parseFloat((c+L).toFixed(2)):-1===p&&K<b?c===B?B:parseFloat((c+L).toFixed(2)):c:w,b=k-h,K=c*b,m.push([a[u],parseFloat(h.toFixed(l))]),q.push(a[u]),r.push(parseFloat(h.toFixed(l))),p=n,n=t,b=k)}return{values:m,xData:q,yData:r}}};d.defaultOptions=m(k.defaultOptions,{lineWidth:0,marker:{enabled:!0},states:{hover:{lineWidthPlus:0}},params:{period:void 0,initialAccelerationFactor:.02,maxAccelerationFactor:.2,
increment:.02,index:2,decimals:4}});return d}(k);e(n.prototype,{nameComponents:void 0});d.registerSeriesType("psar",n);"";return n});t(d,"Stock/Indicators/ROC/ROCIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(g,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return e(g,c)};return function(g,c){function a(){this.constructor=
g}e(g,c);g.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.isArray,n=e.merge;e=e.extend;var r=function(e){function g(){var c=null!==e&&e.apply(this,arguments)||this;c.data=void 0;c.options=void 0;c.points=void 0;return c}h(g,e);g.prototype.getValues=function(c,a){var b=a.period,f=c.xData,g=(c=c.yData)?c.length:0,e=[],d=[],h=[],l=-1;if(!(f.length<=b)){m(c[0])&&(l=a.index);for(a=b;a<g;a++){var k=0>l?(k=c[a-b])?(c[a]-k)/k*100:null:(k=c[a-b][l])?(c[a][l]-
k)/k*100:null;k=[f[a],k];e.push(k);d.push(k[0]);h.push(k[1])}return{values:e,xData:d,yData:h}}};g.defaultOptions=n(k.defaultOptions,{params:{index:3,period:9}});return g}(k);e(r.prototype,{nameBase:"Rate of Change"});d.registerSeriesType("roc",r);"";return r});t(d,"Stock/Indicators/RSI/RSIIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(c,
a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&(c[b]=a[b])};return e(d,g)};return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.sma,m=e.isNumber,n=e.merge;e=function(e){function d(){var g=null!==e&&e.apply(this,arguments)||this;g.data=void 0;g.points=void 0;g.options=void 0;return g}h(d,e);d.prototype.getValues=function(e,c){var a=c.period,b=e.xData,f=e.yData;e=f?f.length:0;var g=
c.decimals,d=1,h=[],k=[],l=[],r=c.index,q=c=0,n;if(!(b.length<a)){if(m(f[0]))var p=f;else r=Math.min(r,f[0].length-1),p=f.map(function(a){return a[r]});for(;d<a;){var u=parseFloat((p[d]-p[d-1]).toFixed(g));0<u?c+=u:q+=Math.abs(u);d++}f=parseFloat((c/(a-1)).toFixed(g));for(n=parseFloat((q/(a-1)).toFixed(g));d<e;d++)u=parseFloat((p[d]-p[d-1]).toFixed(g)),0<u?(c=u,q=0):(c=0,q=Math.abs(u)),f=parseFloat(((f*(a-1)+c)/a).toFixed(g)),n=parseFloat(((n*(a-1)+q)/a).toFixed(g)),c=0===n?100:0===f?0:parseFloat((100-
100/(1+f/n)).toFixed(g)),h.push([b[d],c]),k.push(b[d]),l.push(c);return{values:h,xData:k,yData:l}}};d.defaultOptions=n(k.defaultOptions,{params:{decimals:4,index:3}});return d}(k);d.registerSeriesType("rsi",e);"";return e});t(d,"Stock/Indicators/Stochastic/StochasticIndicator.js",[d["Mixins/MultipleLines.js"],d["Mixins/ReduceArray.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h,k){var m=this&&this.__extends||function(){var c=function(a,b){c=Object.setPrototypeOf||{__proto__:[]}instanceof
Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return c(a,b)};return function(a,b){function f(){this.constructor=a}c(a,b);a.prototype=null===b?Object.create(b):(f.prototype=b.prototype,new f)}}(),n=h.seriesTypes.sma,r=k.extend,l=k.isArray,g=k.merge;k=function(c){function a(){var a=null!==c&&c.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}m(a,c);a.prototype.init=function(){h.seriesTypes.sma.prototype.init.apply(this,
arguments);this.options=g({smoothedLine:{styles:{lineColor:this.color}}},this.options)};a.prototype.getValues=function(a,c){var b=c.periods[0];c=c.periods[1];var f=a.xData,g=(a=a.yData)?a.length:0,d=[],k=[],m=[],q=null,r;if(!(g<b)&&l(a[0])&&4===a[0].length){for(r=b-1;r<g;r++){var p=a.slice(r-b+1,r+1);var u=e.getArrayExtremes(p,2,1);var n=u[0];p=a[r][3]-n;n=u[1]-n;p=p/n*100;k.push(f[r]);m.push([p,null]);r>=b-1+(c-1)&&(q=h.seriesTypes.sma.prototype.getValues.call(this,{xData:k.slice(-c),yData:m.slice(-c)},
{period:c}),q=q.yData[0]);d.push([f[r],p,q]);m[m.length-1][1]=q}return{values:d,xData:k,yData:m}}};a.defaultOptions=g(n.defaultOptions,{params:{index:void 0,period:void 0,periods:[14,3]},marker:{enabled:!1},tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span><b> {series.name}</b><br/>%K: {point.y}<br/>%D: {point.smoothed}<br/>'},smoothedLine:{styles:{lineWidth:1,lineColor:void 0}},dataGrouping:{approximation:"averages"}});return a}(n);r(k.prototype,{nameComponents:["periods"],nameBase:"Stochastic",
pointArrayMap:["y","smoothed"],parallelArrays:["x","y","smoothed"],pointValKey:"y",linesApiNames:["smoothedLine"],drawGraph:d.drawGraph,getTranslatedLinesNames:d.getTranslatedLinesNames,translate:d.translate,toYData:d.toYData});h.registerSeriesType("stochastic",k);"";return k});t(d,"Stock/Indicators/SlowStochastic/SlowStochasticIndicator.js",[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var e=function(c,
a){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,c){a.__proto__=c}||function(a,c){for(var b in c)c.hasOwnProperty(b)&&(a[b]=c[b])};return e(c,a)};return function(c,a){function b(){this.constructor=c}e(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),m=e.seriesTypes.stochastic,n=e.seriesTypes,r=h.extend,l=h.merge;h=function(e){function c(){var a=null!==e&&e.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(c,e);
c.prototype.init=function(){var a=arguments,b=this;d.isParentLoaded(n.stochastic,"stochastic",b.type,function(c){c.prototype.init.apply(b,a)})};c.prototype.getValues=function(a,b){var c=b.periods,e=n.stochastic.prototype.getValues.call(this,a,b);a={values:[],xData:[],yData:[]};b=0;if(e){a.xData=e.xData.slice(c[1]-1);e=e.yData.slice(c[1]-1);var d=n.sma.prototype.getValues.call(this,{xData:a.xData,yData:e},{index:1,period:c[2]});if(d){for(var g=a.xData.length;b<g;b++)a.yData[b]=[e[b][1],d.yData[b-c[2]+
1]||null],a.values[b]=[a.xData[b],e[b][1],d.yData[b-c[2]+1]||null];return a}}};c.defaultOptions=l(m.defaultOptions,{params:{periods:[14,3,3]}});return c}(m);r(h.prototype,{nameBase:"Slow Stochastic"});e.registerSeriesType("slowstochastic",h);"";return h});t(d,"Stock/Indicators/Supertrend/SupertrendIndicator.js",[d["Core/Color/Palette.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"],d["Core/Chart/StockChart.js"]],function(d,e,h,k){function m(a,b,c){return{index:b,close:a.yData[b][c],
x:a.xData[b]}}var n=this&&this.__extends||function(){var a=function(b,c){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return a(b,c)};return function(b,c){function f(){this.constructor=b}a(b,c);b.prototype=null===c?Object.create(c):(f.prototype=c.prototype,new f)}}(),r=e.seriesTypes,l=r.atr,g=r.sma,c=h.addEvent,a=h.correctFloat,b=h.isArray;r=h.extend;var f=h.merge,x=h.objectEach;h=function(e){function h(){var a=
null!==e&&e.apply(this,arguments)||this;a.data=void 0;a.linkedParent=void 0;a.options=void 0;a.points=void 0;return a}n(h,e);h.prototype.init=function(){var a;g.prototype.init.apply(this,arguments);var b=this,f=c(k,"afterLinkSeries",function(){if(b.options){var c=b.options;a=b.linkedParent.options;c.cropThreshold=a.cropThreshold-(c.params.period-1)}f()},{order:1})};h.prototype.drawGraph=function(){var a=this,b=a.options,c=a.linkedParent,e=c?c.points:[],d=a.points,h=a.graph,k=d.length,l=e.length-k;
l=0<l?l:0;for(var r={options:{gapSize:b.gapSize}},n={top:[],bottom:[],intersect:[]},v={top:{styles:{lineWidth:b.lineWidth,lineColor:b.fallingTrendColor||b.color,dashStyle:b.dashStyle}},bottom:{styles:{lineWidth:b.lineWidth,lineColor:b.risingTrendColor||b.color,dashStyle:b.dashStyle}},intersect:b.changeTrendLine},y,t,w,G,F,M,H,I;k--;)y=d[k],t=d[k-1],w=e[k-1+l],G=e[k-2+l],F=e[k+l],M=e[k+l+1],H=y.options.color,I={x:y.x,plotX:y.plotX,plotY:y.plotY,isNull:!1},!G&&w&&c.yData[w.index-1]&&(G=m(c,w.index-
1,3)),!M&&F&&c.yData[F.index+1]&&(M=m(c,F.index+1,3)),!w&&G&&c.yData[G.index+1]?w=m(c,G.index+1,3):!w&&F&&c.yData[F.index-1]&&(w=m(c,F.index-1,3)),y&&w&&F&&G&&y.x!==w.x&&(y.x===F.x?(G=w,w=F):y.x===G.x?(w=G,G={close:c.yData[w.index-1][3],x:c.xData[w.index-1]}):M&&y.x===M.x&&(w=M,G=F)),t&&G&&w?(F={x:t.x,plotX:t.plotX,plotY:t.plotY,isNull:!1},y.y>=w.close&&t.y>=G.close?(y.color=H||b.fallingTrendColor||b.color,n.top.push(I)):y.y<w.close&&t.y<G.close?(y.color=H||b.risingTrendColor||b.color,n.bottom.push(I)):
(n.intersect.push(I),n.intersect.push(F),n.intersect.push(f(F,{isNull:!0})),y.y>=w.close&&t.y<G.close?(y.color=H||b.fallingTrendColor||b.color,t.color=H||b.risingTrendColor||b.color,n.top.push(I),n.top.push(f(F,{isNull:!0}))):y.y<w.close&&t.y>=G.close&&(y.color=H||b.risingTrendColor||b.color,t.color=H||b.fallingTrendColor||b.color,n.bottom.push(I),n.bottom.push(f(F,{isNull:!0}))))):w&&(y.y>=w.close?(y.color=H||b.fallingTrendColor||b.color,n.top.push(I)):(y.color=H||b.risingTrendColor||b.color,n.bottom.push(I)));
x(n,function(b,c){a.points=b;a.options=f(v[c].styles,r);a.graph=a["graph"+c+"Line"];g.prototype.drawGraph.call(a);a["graph"+c+"Line"]=a.graph});a.points=d;a.options=b;a.graph=h};h.prototype.getValues=function(c,f){var e=f.period;f=f.multiplier;var d=c.xData,g=c.yData,h=[],k=[],m=[],r=0===e?0:e-1,n=[],x=[],v;if(!(d.length<=e||!b(g[0])||4!==g[0].length||0>e)){c=l.prototype.getValues.call(this,c,{period:e}).yData;for(v=0;v<c.length;v++){var y=g[r+v];var w=g[r+v-1]||[];var t=n[v-1];var C=x[v-1];var E=
m[v-1];0===v&&(t=C=E=0);e=a((y[1]+y[2])/2+f*c[v]);var H=a((y[1]+y[2])/2-f*c[v]);n[v]=e<t||w[3]>t?e:t;x[v]=H>C||w[3]<C?H:C;if(E===t&&y[3]<n[v]||E===C&&y[3]<x[v])var I=n[v];else if(E===t&&y[3]>n[v]||E===C&&y[3]>x[v])I=x[v];h.push([d[r+v],I]);k.push(d[r+v]);m.push(I)}return{values:h,xData:k,yData:m}}};h.defaultOptions=f(g.defaultOptions,{params:{index:void 0,multiplier:3,period:10},risingTrendColor:d.positiveColor,fallingTrendColor:d.negativeColor,changeTrendLine:{styles:{lineWidth:1,lineColor:d.neutralColor80,
dashStyle:"LongDash"}}});return h}(g);r(h.prototype,{nameBase:"Supertrend",nameComponents:["multiplier","period"],requiredIndicators:["atr"]});e.registerSeriesType("supertrend",h);"";return h});t(d,"Stock/Indicators/VBP/VBPPoint.js",[d["Core/Series/Point.js"],d["Core/Series/SeriesRegistry.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,h){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,d){e.__proto__=d}||function(e,d){for(var g in d)d.hasOwnProperty(g)&&
(e[g]=d[g])};return e(d,h)};return function(d,h){function k(){this.constructor=d}e(d,h);d.prototype=null===h?Object.create(h):(k.prototype=h.prototype,new k)}}();return function(e){function k(){return null!==e&&e.apply(this,arguments)||this}h(k,e);k.prototype.destroy=function(){this.negativeGraphic&&(this.negativeGraphic=this.negativeGraphic.destroy());return d.prototype.destroy.apply(this,arguments)};return k}(e.seriesTypes.sma.prototype.pointClass)});t(d,"Stock/Indicators/VBP/VBPIndicator.js",[d["Stock/Indicators/VBP/VBPPoint.js"],
d["Core/Animation/AnimationUtilities.js"],d["Core/Globals.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"],d["Core/Chart/StockChart.js"]],function(d,e,h,k,m,t){var r=this&&this.__extends||function(){var a=function(b,c){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return a(b,c)};return function(b,c){function f(){this.constructor=b}a(b,c);b.prototype=null===c?Object.create(c):(f.prototype=
c.prototype,new f)}}(),l=e.animObject;e=h.noop;var g=k.seriesTypes.sma,c=m.addEvent,a=m.arrayMax,b=m.arrayMin,f=m.correctFloat,n=m.error,v=m.extend,y=m.isArray,w=m.merge,E=Math.abs,z=k.seriesTypes.column.prototype;m=function(e){function d(){var a=null!==e&&e.apply(this,arguments)||this;a.data=void 0;a.negWidths=void 0;a.options=void 0;a.points=void 0;a.posWidths=void 0;a.priceZones=void 0;a.rangeStep=void 0;a.volumeDataArray=void 0;a.zoneStarts=void 0;a.zoneLinesSVG=void 0;return a}r(d,e);d.prototype.init=
function(a){var b=this,f,e,d;h.seriesTypes.sma.prototype.init.apply(b,arguments);var g=c(t,"afterLinkSeries",function(){b.options&&(f=b.options.params,e=b.linkedParent,d=a.get(f.volumeSeriesID),b.addCustomEvents(e,d));g()},{order:1});return b};d.prototype.addCustomEvents=function(a,b){function f(){e.chart.redraw();e.setData([]);e.zoneStarts=[];e.zoneLinesSVG&&(e.zoneLinesSVG=e.zoneLinesSVG.destroy())}var e=this;e.dataEventsToUnbind.push(c(a,"remove",function(){f()}));b&&e.dataEventsToUnbind.push(c(b,
"remove",function(){f()}));return e};d.prototype.animate=function(a){var b=this,c=b.chart.inverted,f=b.group,e={};!a&&f&&(a=c?b.yAxis.top:b.xAxis.left,c?(f["forceAnimate:translateY"]=!0,e.translateY=a):(f["forceAnimate:translateX"]=!0,e.translateX=a),f.animate(e,v(l(b.options.animation),{step:function(a,c){b.group.attr({scaleX:Math.max(.001,c.pos)})}})))};d.prototype.drawPoints=function(){this.options.volumeDivision.enabled&&(this.posNegVolume(!0,!0),z.drawPoints.apply(this,arguments),this.posNegVolume(!1,
!1));z.drawPoints.apply(this,arguments)};d.prototype.posNegVolume=function(a,b){var c=b?["positive","negative"]:["negative","positive"],f=this.options.volumeDivision,e=this.points.length,d=[],g=[],h=0,k;a?(this.posWidths=d,this.negWidths=g):(d=this.posWidths,g=this.negWidths);for(;h<e;h++){var l=this.points[h];l[c[0]+"Graphic"]=l.graphic;l.graphic=l[c[1]+"Graphic"];if(a){var p=l.shapeArgs.width;var m=this.priceZones[h];(k=m.wholeVolumeData)?(d.push(p/k*m.positiveVolumeData),g.push(p/k*m.negativeVolumeData)):
(d.push(0),g.push(0))}l.color=b?f.styles.positiveColor:f.styles.negativeColor;l.shapeArgs.width=b?this.posWidths[h]:this.negWidths[h];l.shapeArgs.x=b?l.shapeArgs.x:this.posWidths[h]}};d.prototype.translate=function(){var b=this,c=b.options,e=b.chart,d=b.yAxis,g=d.min,h=b.options.zoneLines,k=b.priceZones,l=0,m,q,r;z.translate.apply(b);var n=b.points;if(n.length){var v=.5>c.pointPadding?c.pointPadding:.1;c=b.volumeDataArray;var x=a(c);var y=e.plotWidth/2;var t=e.plotTop;var w=E(d.toPixels(g)-d.toPixels(g+
b.rangeStep));var C=E(d.toPixels(g)-d.toPixels(g+b.rangeStep));v&&(g=E(w*(1-2*v)),l=E((w-g)/2),w=E(g));n.forEach(function(a,c){q=a.barX=a.plotX=0;r=a.plotY=d.toPixels(k[c].start)-t-(d.reversed?w-C:w)-l;m=f(y*k[c].wholeVolumeData/x);a.pointWidth=m;a.shapeArgs=b.crispCol.apply(b,[q,r,m,w]);a.volumeNeg=k[c].negativeVolumeData;a.volumePos=k[c].positiveVolumeData;a.volumeAll=k[c].wholeVolumeData});h.enabled&&b.drawZones(e,d,b.zoneStarts,h.styles)}};d.prototype.getValues=function(a,b){var c=a.processedXData,
f=a.processedYData,e=this.chart,d=b.ranges,g=[],h=[],k=[],l;if(a.chart)if(l=e.get(b.volumeSeriesID))if((b=y(f[0]))&&4!==f[0].length)n("Type of "+a.name+" series is different than line, OHLC or candlestick.",!0,e);else return(this.priceZones=this.specifyZones(b,c,f,d,l)).forEach(function(a,b){g.push([a.x,a.end]);h.push(g[b][0]);k.push(g[b][1])}),{values:g,xData:h,yData:k};else n("Series "+b.volumeSeriesID+" not found! Check `volumeSeriesID`.",!0,e);else n("Base series not found! In case it has been removed, add a new one.",
!0,e)};d.prototype.specifyZones=function(c,e,d,g,h){if(c){var k=d.length;for(var l=d[0][3],m=l,p=1,q;p<k;p++)q=d[p][3],q<l&&(l=q),q>m&&(m=q);k={min:l,max:m}}else k=!1;k=(l=k)?l.min:b(d);q=l?l.max:a(d);l=this.zoneStarts=[];m=[];var r=0;p=1;if(!k||!q)return this.points.length&&(this.setData([]),this.zoneStarts=[],this.zoneLinesSVG&&(this.zoneLinesSVG=this.zoneLinesSVG.destroy())),[];var n=this.rangeStep=f(q-k)/g;for(l.push(k);r<g-1;r++)l.push(f(l[r]+n));l.push(q);for(g=l.length;p<g;p++)m.push({index:p-
1,x:e[0],start:l[p-1],end:l[p]});return this.volumePerZone(c,m,h,e,d)};d.prototype.volumePerZone=function(a,b,c,f,e){var d=this,g=c.processedXData,h=c.processedYData,k=b.length-1,l=e.length;c=h.length;var m,p,q,r,n;E(l-c)&&(f[0]!==g[0]&&h.unshift(0),f[l-1]!==g[c-1]&&h.push(0));d.volumeDataArray=[];b.forEach(function(b){b.wholeVolumeData=0;b.positiveVolumeData=0;for(n=b.negativeVolumeData=0;n<l;n++)q=p=!1,r=a?e[n][3]:e[n],m=n?a?e[n-1][3]:e[n-1]:r,r<=b.start&&0===b.index&&(p=!0),r>=b.end&&b.index===
k&&(q=!0),(r>b.start||p)&&(r<b.end||q)&&(b.wholeVolumeData+=h[n],m>r?b.negativeVolumeData+=h[n]:b.positiveVolumeData+=h[n]);d.volumeDataArray.push(b.wholeVolumeData)});return b};d.prototype.drawZones=function(a,b,c,f){var e=a.renderer,d=this.zoneLinesSVG,g=[],h=a.plotWidth,k=a.plotTop,l;c.forEach(function(c){l=b.toPixels(c)-k;g=g.concat(a.renderer.crispLine([["M",0,l],["L",h,l]],f.lineWidth))});d?d.animate({d:g}):d=this.zoneLinesSVG=e.path(g).attr({"stroke-width":f.lineWidth,stroke:f.color,dashstyle:f.dashStyle,
zIndex:this.group.zIndex+.1}).add(this.group)};d.defaultOptions=w(g.defaultOptions,{params:{index:void 0,period:void 0,ranges:12,volumeSeriesID:"volume"},zoneLines:{enabled:!0,styles:{color:"#0A9AC9",dashStyle:"LongDash",lineWidth:1}},volumeDivision:{enabled:!0,styles:{positiveColor:"rgba(144, 237, 125, 0.8)",negativeColor:"rgba(244, 91, 91, 0.8)"}},animationLimit:1E3,enableMouseTracking:!1,pointPadding:0,zIndex:-1,crisp:!0,dataGrouping:{enabled:!1},dataLabels:{allowOverlap:!0,enabled:!0,format:"P: {point.volumePos:.2f} | N: {point.volumeNeg:.2f}",
padding:0,style:{fontSize:"7px"},verticalAlign:"top"}});return d}(g);v(m.prototype,{nameBase:"Volume by Price",nameComponents:["ranges"],bindTo:{series:!1,eventName:"afterSetExtremes"},calculateOn:"render",pointClass:d,markerAttribs:e,drawGraph:e,getColumnMetrics:z.getColumnMetrics,crispCol:z.crispCol});k.registerSeriesType("vbp",m);"";return m});t(d,"Stock/Indicators/VWAP/VWAPIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=
function(d,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return e(d,c)};return function(d,c){function a(){this.constructor=d}e(d,c);d.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.error,n=e.isArray,r=e.merge;e=function(e){function d(){var c=null!==e&&e.apply(this,arguments)||this;c.data=void 0;c.points=void 0;c.options=void 0;return c}h(d,e);
d.prototype.getValues=function(c,a){var b=c.chart,f=c.xData;c=c.yData;var e=a.period,d=!0,g;if(g=b.get(a.volumeSeriesID))return n(c[0])||(d=!1),this.calculateVWAPValues(d,f,c,g,e);m("Series "+a.volumeSeriesID+" not found! Check `volumeSeriesID`.",!0,b)};d.prototype.calculateVWAPValues=function(c,a,b,f,e){var d=f.yData,g=f.xData.length,h=a.length;f=[];var k=[],l=[],m=[],r=[],p;g=h<=g?h:g;for(p=h=0;h<g;h++){var n=c?(b[h][1]+b[h][2]+b[h][3])/3:b[h];n*=d[h];n=p?f[h-1]+n:n;var x=p?k[h-1]+d[h]:d[h];f.push(n);
k.push(x);r.push([a[h],n/x]);l.push(r[h][0]);m.push(r[h][1]);p++;p===e&&(p=0)}return{values:r,xData:l,yData:m}};d.defaultOptions=r(k.defaultOptions,{params:{index:void 0,period:30,volumeSeriesID:"volume"}});return d}(k);d.registerSeriesType("vwap",e);"";return e});t(d,"Stock/Indicators/WilliamsR/WilliamsRIndicator.js",[d["Mixins/ReduceArray.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var e=function(c,a){e=Object.setPrototypeOf||
{__proto__:[]}instanceof Array&&function(a,c){a.__proto__=c}||function(a,c){for(var b in c)c.hasOwnProperty(b)&&(a[b]=c[b])};return e(c,a)};return function(c,a){function b(){this.constructor=c}e(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),m=d.getArrayExtremes,n=e.seriesTypes.sma;d=h.extend;var r=h.isArray,l=h.merge;h=function(e){function c(){var a=null!==e&&e.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}k(c,e);c.prototype.getValues=
function(a,b){b=b.period;var c=a.xData,e=(a=a.yData)?a.length:0,d=[],g=[],h=[],k;if(!(c.length<b)&&r(a[0])&&4===a[0].length){for(k=b-1;k<e;k++){var l=a.slice(k-b+1,k+1);var q=m(l,2,1);l=q[0];q=q[1];var n=a[k][3];l=(q-n)/(q-l)*-100;c[k]&&(d.push([c[k],l]),g.push(c[k]),h.push(l))}return{values:d,xData:g,yData:h}}};c.defaultOptions=l(n.defaultOptions,{params:{index:void 0,period:14}});return c}(n);d(h.prototype,{nameBase:"Williams %R"});e.registerSeriesType("williamsr",h);"";return h});t(d,"Stock/Indicators/WMA/WMAIndicator.js",
[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){function h(e,c){c*=(c+1)/2;return e.reduce(function(a,b,c){return[null,a[1]+b[1]*(c+1)]})[1]/c}function k(e,c,a,b){a=h(e,e.length);c=c[b-1];e.shift();return[c,a]}var m=this&&this.__extends||function(){var e=function(c,a){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,c){a.__proto__=c}||function(a,c){for(var b in c)c.hasOwnProperty(b)&&(a[b]=c[b])};return e(c,a)};return function(c,a){function b(){this.constructor=
c}e(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),n=d.seriesTypes.sma,r=e.isArray,l=e.merge;e=function(e){function c(){var a=null!==e&&e.apply(this,arguments)||this;a.data=void 0;a.options=void 0;a.points=void 0;return a}m(c,e);c.prototype.getValues=function(a,b){var c=b.period,e=a.xData,d=(a=a.yData)?a.length:0,g=1,h=e[0],l=a[0],m=[],q=[],n=[],p=-1;if(!(e.length<c)){r(a[0])&&(p=b.index,l=a[0][p]);for(b=[[h,l]];g!==c;)b.push([e[g],0>p?a[g]:a[g][p]]),g++;for(c=g;c<
d;c++)g=k(b,e,a,c),m.push(g),q.push(g[0]),n.push(g[1]),b.push([e[c],0>p?a[c]:a[c][p]]);g=k(b,e,a,c);m.push(g);q.push(g[0]);n.push(g[1]);return{values:m,xData:q,yData:n}}};c.defaultOptions=l(n.defaultOptions,{params:{index:3,period:9}});return c}(n);d.registerSeriesType("wma",e);"";return e});t(d,"Stock/Indicators/Zigzag/ZigzagIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof
Array&&function(c,a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&(c[b]=a[b])};return e(d,g)};return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.sma,m=e.merge;e=e.extend;var n=function(e){function d(){var d=null!==e&&e.apply(this,arguments)||this;d.data=void 0;d.points=void 0;d.options=void 0;return d}h(d,e);d.prototype.getValues=function(e,c){var a=c.lowIndex,b=c.highIndex,f=c.deviation/
100;c=1+f;var d=1-f;f=e.xData;var g=e.yData;e=g?g.length:0;var h=[],k=[],l=[],m,n,r=!1,p=!1;if(!(!f||1>=f.length||e&&("undefined"===typeof g[0][a]||"undefined"===typeof g[0][b]))){var u=g[0][a];var t=g[0][b];for(m=1;m<e;m++){if(g[m][a]<=t*d){h.push([f[0],t]);var w=[f[m],g[m][a]];r=n=!0}else g[m][b]>=u*c&&(h.push([f[0],u]),w=[f[m],g[m][b]],n=!1,r=!0);if(r){k.push(h[0][0]);l.push(h[0][1]);var B=m++;m=e}}for(m=B;m<e;m++)n?(g[m][a]<=w[1]&&(w=[f[m],g[m][a]]),g[m][b]>=w[1]*c&&(p=b)):(g[m][b]>=w[1]&&(w=
[f[m],g[m][b]]),g[m][a]<=w[1]*d&&(p=a)),!1!==p&&(h.push(w),k.push(w[0]),l.push(w[1]),w=[f[m],g[m][p]],n=!n,p=!1);a=h.length;0!==a&&h[a-1][0]<f[e-1]&&(h.push(w),k.push(w[0]),l.push(w[1]));return{values:h,xData:k,yData:l}}};d.defaultOptions=m(k.defaultOptions,{params:{index:void 0,period:void 0,lowIndex:2,highIndex:1,deviation:1}});return d}(k);e(n.prototype,{nameComponents:["deviation"],nameSuffixes:["%"],nameBase:"Zig Zag"});d.registerSeriesType("zigzag",n);"";return n});t(d,"Stock/Indicators/LinearRegression/LinearRegression.js",
[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,c){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return e(d,c)};return function(d,c){function a(){this.constructor=d}e(d,c);d.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.isArray,n=e.extend,r=e.merge;e=function(e){function d(){var c=
null!==e&&e.apply(this,arguments)||this;c.data=void 0;c.options=void 0;c.points=void 0;return c}h(d,e);d.prototype.getRegressionLineParameters=function(c,a){var b=this.options.params.index,e=function(a,b){return m(a)?a[b]:a},d=c.reduce(function(a,b){return b+a},0),g=a.reduce(function(a,c){return e(c,b)+a},0);d/=c.length;g/=a.length;var h=0,k=0,l;for(l=0;l<c.length;l++){var n=c[l]-d;var q=e(a[l],b)-g;h+=n*q;k+=Math.pow(n,2)}c=k?h/k:0;return{slope:c,intercept:g-c*d}};d.prototype.getEndPointY=function(c,
a){return c.slope*a+c.intercept};d.prototype.transformXData=function(c,a){var b=c[0];return c.map(function(c){return(c-b)/a})};d.prototype.findClosestDistance=function(c){var a,b;for(b=1;b<c.length-1;b++){var e=c[b]-c[b-1];0<e&&("undefined"===typeof a||e<a)&&(a=e)}return a};d.prototype.getValues=function(c,a){var b=c.xData;c=c.yData;a=a.period;var e,d={xData:[],yData:[],values:[]},g=this.options.params.xAxisUnit||this.findClosestDistance(b);for(e=a-1;e<=b.length-1;e++){var h=e-a+1;var k=e+1;var l=
b[e];var m=b.slice(h,k);h=c.slice(h,k);k=this.transformXData(m,g);m=this.getRegressionLineParameters(k,h);h=this.getEndPointY(m,k[k.length-1]);d.values.push({regressionLineParameters:m,x:l,y:h});d.xData.push(l);d.yData.push(h)}return d};d.defaultOptions=r(k.defaultOptions,{params:{xAxisUnit:null},tooltip:{valueDecimals:4}});return d}(k);n(e.prototype,{nameBase:"Linear Regression Indicator"});d.registerSeriesType("linearRegression",e);"";return e});t(d,"Stock/Indicators/LinearRegressionSlopes/LinearRegressionSlopes.js",
[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(c,a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&(c[b]=a[b])};return e(d,g)};return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.linearRegression,m=e.extend,n=e.merge;e=function(e){function d(){var d=
null!==e&&e.apply(this,arguments)||this;d.data=void 0;d.options=void 0;d.points=void 0;return d}h(d,e);d.prototype.getEndPointY=function(e){return e.slope};d.defaultOptions=n(k.defaultOptions);return d}(k);m(e.prototype,{nameBase:"Linear Regression Slope Indicator"});d.registerSeriesType("linearRegressionSlope",e);"";return e});t(d,"Stock/Indicators/LinearRegressionIntercept/LinearRegressionIntercept.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||
function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(c,a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&(c[b]=a[b])};return e(d,g)};return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.linearRegression,m=e.extend,n=e.merge;e=function(d){function e(){var e=null!==d&&d.apply(this,arguments)||this;e.data=void 0;e.options=void 0;e.points=void 0;
return e}h(e,d);e.prototype.getEndPointY=function(e){return e.intercept};e.defaultOptions=n(k.defaultOptions);return e}(k);m(e.prototype,{nameBase:"Linear Regression Intercept Indicator"});d.registerSeriesType("linearRegressionIntercept",e);"";return e});t(d,"Stock/Indicators/LinearRegressionAngle/LinearRegressionAngle.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var e=function(d,g){e=Object.setPrototypeOf||{__proto__:[]}instanceof
Array&&function(c,a){c.__proto__=a}||function(c,a){for(var b in a)a.hasOwnProperty(b)&&(c[b]=a[b])};return e(d,g)};return function(d,g){function c(){this.constructor=d}e(d,g);d.prototype=null===g?Object.create(g):(c.prototype=g.prototype,new c)}}(),k=d.seriesTypes.linearRegression,m=e.extend,n=e.merge;e=function(e){function d(){var d=null!==e&&e.apply(this,arguments)||this;d.data=void 0;d.options=void 0;d.points=void 0;return d}h(d,e);d.prototype.slopeToAngle=function(d){return 180/Math.PI*Math.atan(d)};
d.prototype.getEndPointY=function(d){return this.slopeToAngle(d.slope)};d.defaultOptions=n(k.defaultOptions,{tooltip:{pointFormat:'<span style="color:{point.color}">\u25cf</span>{series.name}: <b>{point.y}\u00b0</b><br/>'}});return d}(k);m(e.prototype,{nameBase:"Linear Regression Angle Indicator"});d.registerSeriesType("linearRegressionAngle",e);"";return e});t(d,"Stock/Indicators/ABands/ABandsIndicator.js",[d["Mixins/MultipleLines.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,
e,h){var k=this&&this.__extends||function(){var d=function(c,a){d=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,c){a.__proto__=c}||function(a,c){for(var b in c)c.hasOwnProperty(b)&&(a[b]=c[b])};return d(c,a)};return function(c,a){function b(){this.constructor=c}d(c,a);c.prototype=null===a?Object.create(a):(b.prototype=a.prototype,new b)}}(),m=e.seriesTypes.sma,n=h.correctFloat,r=h.extend,l=h.merge;h=function(d){function c(){var a=null!==d&&d.apply(this,arguments)||this;a.data=
void 0;a.options=void 0;a.points=void 0;return a}k(c,d);c.prototype.getValues=function(a,b){var c=b.period,e=b.factor;b=b.index;var g=a.xData,h=(a=a.yData)?a.length:0,k=[],l=[],m=[],q=[],r=[],p;if(!(h<c)){for(p=0;p<=h;p++){if(p<h){var u=a[p][2];var t=a[p][1];var w=e;u=n(t-u)/(n(t+u)/2)*1E3*w;k.push(a[p][1]*n(1+2*u));l.push(a[p][2]*n(1-2*u))}if(p>=c){u=g.slice(p-c,p);var B=a.slice(p-c,p);w=d.prototype.getValues.call(this,{xData:u,yData:k.slice(p-c,p)},{period:c});t=d.prototype.getValues.call(this,
{xData:u,yData:l.slice(p-c,p)},{period:c});B=d.prototype.getValues.call(this,{xData:u,yData:B},{period:c,index:b});u=B.xData[0];w=w.yData[0];t=t.yData[0];B=B.yData[0];m.push([u,w,B,t]);q.push(u);r.push([w,B,t])}}return{values:m,xData:q,yData:r}}};c.defaultOptions=l(m.defaultOptions,{params:{period:20,factor:.001,index:3},lineWidth:1,topLine:{styles:{lineWidth:1}},bottomLine:{styles:{lineWidth:1}},dataGrouping:{approximation:"averages"}});return c}(m);r(h.prototype,{drawGraph:d.drawGraph,getTranslatedLinesNames:d.getTranslatedLinesNames,
linesApiNames:["topLine","bottomLine"],nameBase:"Acceleration Bands",nameComponents:["period","factor"],pointArrayMap:["top","middle","bottom"],pointValKey:"middle",toYData:d.toYData,translate:d.translate});e.registerSeriesType("abands",h);"";return h});t(d,"Stock/Indicators/TrendLine/TrendLineIndicator.js",[d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e){var h=this&&this.__extends||function(){var d=function(e,c){d=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,
b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return d(e,c)};return function(e,c){function a(){this.constructor=e}d(e,c);e.prototype=null===c?Object.create(c):(a.prototype=c.prototype,new a)}}(),k=d.seriesTypes.sma,m=e.extend,n=e.merge,r=e.isArray;e=function(d){function e(){var c=null!==d&&d.apply(this,arguments)||this;c.data=void 0;c.options=void 0;c.points=void 0;return c}h(e,d);e.prototype.getValues=function(c,a){var b=c.xData,d=c.yData;c=[];var e=[],g=[],h=
0,k=0,l=0,m=0,n=b.length,t=a.index;for(a=0;a<n;a++){var p=b[a];var u=r(d[a])?d[a][t]:d[a];h+=p;k+=u;l+=p*u;m+=p*p}d=(n*l-h*k)/(n*m-h*h);isNaN(d)&&(d=0);h=(k-d*h)/n;for(a=0;a<n;a++)p=b[a],u=d*p+h,c[a]=[p,u],e[a]=p,g[a]=u;return{xData:e,yData:g,values:c}};e.defaultOptions=n(k.defaultOptions,{params:{period:void 0,index:3}});return e}(k);m(e.prototype,{nameBase:"Trendline",nameComponents:!1});d.registerSeriesType("trendline",e);"";return e});t(d,"Stock/Indicators/DisparityIndex/DisparityIndexIndicator.js",
[d["Mixins/IndicatorRequired.js"],d["Core/Series/SeriesRegistry.js"],d["Core/Utilities.js"]],function(d,e,h){var k=this&&this.__extends||function(){var a=function(b,c){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,b){a.__proto__=b}||function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c])};return a(b,c)};return function(b,c){function d(){this.constructor=b}a(b,c);b.prototype=null===c?Object.create(c):(d.prototype=c.prototype,new d)}}(),m=e.seriesTypes.sma,n=h.correctFloat,
r=h.defined,l=h.extend,g=h.isArray,c=h.merge;h=function(a){function b(){var b=null!==a&&a.apply(this,arguments)||this;b.averageIndicator=void 0;b.data=void 0;b.options=void 0;b.points=void 0;return b}k(b,a);b.prototype.init=function(){var a=arguments,b=this,c=a[1].params;c=c&&c.average?c.average:void 0;b.averageIndicator=e.seriesTypes[c]||m;d.isParentLoaded(b.averageIndicator,c,b.type,function(c){c.prototype.init.apply(b,a)})};b.prototype.calculateDisparityIndex=function(a,b){return n(a-b)/b*100};
b.prototype.getValues=function(a,b){var c=b.index,d=a.xData,e=a.yData,f=e?e.length:0,h=[],k=[],l=[],m=this.averageIndicator,n=g(e[0]);b=m.prototype.getValues(a,b);a=b.yData;b=d.indexOf(b.xData[0]);if(a&&0!==a.length&&r(c)&&!(e.length<=b)){for(m=b;m<f;m++){var t=this.calculateDisparityIndex(n?e[m][c]:e[m],a[m-b]);h.push([d[m],t]);k.push(d[m]);l.push(t)}return{values:h,xData:k,yData:l}}};b.defaultOptions=c(m.defaultOptions,{params:{average:"sma",index:3},marker:{enabled:!1},dataGrouping:{approximation:"averages"}});
return b}(m);l(h.prototype,{nameBase:"Disparity Index",nameComponents:["period","average"]});e.registerSeriesType("disparityindex",h);"";return h});t(d,"masters/indicators/indicators-all.src.js",[],function(){})});
//# sourceMappingURL=indicators-all.js.map