/*
 Highstock JS v9.2.1 (2021-08-19)

 Data grouping module

 (c) 2010-2021 Torstein Hnsi

 License: www.highcharts.com/license
*/
'use strict';(function(d){"object"===typeof module&&module.exports?(d["default"]=d,module.exports=d):"function"===typeof define&&define.amd?define("highcharts/modules/datagrouping",["highcharts"],function(z){d(z);d.Highcharts=z;return d}):d("undefined"!==typeof Highcharts?Highcharts:void 0)})(function(d){function z(d,z,f,A){d.hasOwnProperty(z)||(d[z]=A.apply(null,f))}d=d?d._modules:{};z(d,"Extensions/DataGrouping.js",[d["Core/Axis/Axis.js"],d["Core/Axis/DateTimeAxis.js"],d["Core/FormatUtilities.js"],
d["Core/Globals.js"],d["Core/Series/Point.js"],d["Core/Series/Series.js"],d["Core/Tooltip.js"],d["Core/DefaultOptions.js"],d["Core/Utilities.js"]],function(d,z,f,A,L,E,M,N,e){var C=f.format,r=E.prototype;f=e.addEvent;var O=e.arrayMax,P=e.arrayMin,Q=e.correctFloat,D=e.defined,G=e.error,R=e.extend,q=e.isNumber,F=e.merge,B=e.pick;"";var n=A.approximations={sum:function(a){var c=a.length;if(!c&&a.hasNulls)var b=null;else if(c)for(b=0;c--;)b+=a[c];return b},average:function(a){var c=a.length;a=n.sum(a);
q(a)&&c&&(a=Q(a/c));return a},averages:function(){var a=[];[].forEach.call(arguments,function(c){a.push(n.average(c))});return"undefined"===typeof a[0]?void 0:a},open:function(a){return a.length?a[0]:a.hasNulls?null:void 0},high:function(a){return a.length?O(a):a.hasNulls?null:void 0},low:function(a){return a.length?P(a):a.hasNulls?null:void 0},close:function(a){return a.length?a[a.length-1]:a.hasNulls?null:void 0},ohlc:function(a,c,b,h){a=n.open(a);c=n.high(c);b=n.low(b);h=n.close(h);if(q(a)||q(c)||
q(b)||q(h))return[a,c,b,h]},range:function(a,c){a=n.low(a);c=n.high(c);if(q(a)||q(c))return[a,c];if(null===a&&null===c)return null}};e=function(a,c,b,h){var g=this,d=g.data,u=g.options&&g.options.data,k=[],H=[],I=[],t=a.length,l=!!c,m=[],v=g.pointArrayMap,e=v&&v.length,w=["x"].concat(v||["y"]),z=this.options.dataGrouping&&this.options.dataGrouping.groupAll,f=0,r=0,x;h="function"===typeof h?h:n[h]?n[h]:n[g.getDGApproximation&&g.getDGApproximation()||"average"];e?v.forEach(function(){m.push([])}):m.push([]);
var A=e||1;for(x=0;x<=t&&!(a[x]>=b[0]);x++);for(x;x<=t;x++){for(;"undefined"!==typeof b[f+1]&&a[x]>=b[f+1]||x===t;){var p=b[f];g.dataGroupInfo={start:z?r:g.cropStart+r,length:m[0].length};var B=h.apply(g,m);g.pointClass&&!D(g.dataGroupInfo.options)&&(g.dataGroupInfo.options=F(g.pointClass.prototype.optionsToObject.call({series:g},g.options.data[g.cropStart+r])),w.forEach(function(a){delete g.dataGroupInfo.options[a]}));"undefined"!==typeof B&&(k.push(p),H.push(B),I.push(g.dataGroupInfo));r=x;for(p=
0;p<A;p++)m[p].length=0,m[p].hasNulls=!1;f+=1;if(x===t)break}if(x===t)break;if(v){p=g.options.dataGrouping&&g.options.dataGrouping.groupAll?x:g.cropStart+x;B=d&&d[p]||g.pointClass.prototype.applyOptions.apply({series:g},[u[p]]);var y=void 0;for(p=0;p<e;p++)y=B[v[p]],q(y)?m[p].push(y):null===y&&(m[p].hasNulls=!0)}else p=l?c[x]:null,q(p)?m[0].push(p):null===p&&(m[0].hasNulls=!0)}return{groupedXData:k,groupedYData:H,groupMap:I}};var J={approximations:n,groupData:e},S=r.generatePoints,y={groupPixelWidth:2,
dateTimeLabelFormats:{millisecond:["%A, %b %e, %H:%M:%S.%L","%A, %b %e, %H:%M:%S.%L","-%H:%M:%S.%L"],second:["%A, %b %e, %H:%M:%S","%A, %b %e, %H:%M:%S","-%H:%M:%S"],minute:["%A, %b %e, %H:%M","%A, %b %e, %H:%M","-%H:%M"],hour:["%A, %b %e, %H:%M","%A, %b %e, %H:%M","-%H:%M"],day:["%A, %b %e, %Y","%A, %b %e","-%A, %b %e, %Y"],week:["Week from %A, %b %e, %Y","%A, %b %e","-%A, %b %e, %Y"],month:["%B %Y","%B","-%B %Y"],year:["%Y","%Y","-%Y"]}},K={line:{},spline:{},area:{},areaspline:{},arearange:{},column:{groupPixelWidth:10},
columnrange:{groupPixelWidth:10},candlestick:{groupPixelWidth:10},ohlc:{groupPixelWidth:5},heikinashi:{groupPixelWidth:10}},T=A.defaultDataGroupingUnits=[["millisecond",[1,2,5,10,20,25,50,100,200,500]],["second",[1,2,5,10,15,30]],["minute",[1,2,5,10,15,30]],["hour",[1,2,3,4,6,8,12]],["day",[1]],["week",[1]],["month",[1,3,6]],["year",null]];r.getDGApproximation=function(){return this.is("arearange")?"range":this.is("ohlc")?"ohlc":this.is("column")?"sum":"average"};r.groupData=e;r.applyGrouping=function(){var a=
this.chart,c=this.options.dataGrouping,b=!1!==this.allowDG&&c&&B(c.enabled,a.options.isStock),h=this.visible||!a.options.chart.ignoreHiddenSeries,g,d=this.currentDataGrouping,u=!1;b&&!this.requireSorting&&(this.requireSorting=u=!0);var k=!this.isCartesian||this.isDirty||this.xAxis.isDirty||this.yAxis.isDirty?void 0:!1;u&&(this.requireSorting=!1);if(!k&&b){this.destroyGroupedData();k=c.groupAll?this.xData:this.processedXData;var e=c.groupAll?this.yData:this.processedYData;u=a.plotSizeX;b=this.xAxis;
var f=b.options.ordinal,t=this.groupPixelWidth;if(t&&k&&k.length){this.isDirty=g=!0;this.points=null;var l=b.getExtremes();var m=l.min;l=l.max;f=f&&b.ordinal&&b.ordinal.getGroupIntervalFactor(m,l,this)||1;u=b.getTimeTicks(z.Additions.prototype.normalizeTimeTickInterval(t*(l-m)/u*f,c.units||T),Math.min(m,k[0]),Math.max(l,k[k.length-1]),b.options.startOfWeek,k,this.closestPointRange);t=r.groupData.apply(this,[k,e,u,c.approximation]);k=t.groupedXData;e=t.groupedYData;f=0;c&&c.smoothed&&k.length&&(c.firstAnchor=
"firstPoint",c.anchor="middle",c.lastAnchor="lastPoint",G(32,!1,a,{"dataGrouping.smoothed":"use dataGrouping.anchor"}));a=k;var v=this.options.dataGrouping;m=this.currentDataGrouping&&this.currentDataGrouping.gapSize;if(v&&this.xData&&m&&this.groupMap){var n=a.length-1;var w=v.anchor;var y=B(v.firstAnchor,w);v=B(v.lastAnchor,w);if(w&&"start"!==w){var A=m*{middle:.5,end:1}[w];for(w=a.length-1;w--&&0<w;)a[w]+=A}if(y&&"start"!==y&&this.xData[0]>=a[0]){w=this.groupMap[0].start;A=this.groupMap[0].length;
var C=void 0;q(w)&&q(A)&&(C=w+(A-1));a[0]={middle:a[0]+.5*m,end:a[0]+m,firstPoint:this.xData[0],lastPoint:C&&this.xData[C]}[y]}v&&"start"!==v&&m&&a[n]>=l-m&&(l=this.groupMap[this.groupMap.length-1].start,a[n]={middle:a[n]+.5*m,end:a[n]+m,firstPoint:l&&this.xData[l],lastPoint:this.xData[this.xData.length-1]}[v])}for(l=1;l<u.length;l++)u.info.segmentStarts&&-1!==u.info.segmentStarts.indexOf(l)||(f=Math.max(u[l]-u[l-1],f));l=u.info;l.gapSize=f;this.closestPointRange=u.info.totalRange;this.groupMap=t.groupMap;
if(h){h=k;if(D(h[0])&&q(b.min)&&q(b.dataMin)&&h[0]<b.min){if(!D(b.options.min)&&b.min<=b.dataMin||b.min===b.dataMin)b.min=Math.min(h[0],b.min);b.dataMin=Math.min(h[0],b.dataMin)}if(D(h[h.length-1])&&q(b.max)&&q(b.dataMax)&&h[h.length-1]>b.max){if(!D(b.options.max)&&q(b.dataMax)&&b.max>=b.dataMax||b.max===b.dataMax)b.max=Math.max(h[h.length-1],b.max);b.dataMax=Math.max(h[h.length-1],b.dataMax)}}c.groupAll&&(this.allGroupedData=e,c=this.cropData(k,e,b.min,b.max,1),k=c.xData,e=c.yData,this.cropStart=
c.start);this.processedXData=k;this.processedYData=e}else this.groupMap=null;this.hasGroupedData=g;this.currentDataGrouping=l;this.preventGraphAnimation=(d&&d.totalRange)!==(l&&l.totalRange)}};r.destroyGroupedData=function(){this.groupedData&&(this.groupedData.forEach(function(a,c){a&&(this.groupedData[c]=a.destroy?a.destroy():null)},this),this.groupedData.length=0)};r.generatePoints=function(){S.apply(this);this.destroyGroupedData();this.groupedData=this.hasGroupedData?this.points:null};d.prototype.applyGrouping=
function(){var a=this;a.series.forEach(function(c){c.groupPixelWidth=void 0;c.groupPixelWidth=a.getGroupPixelWidth&&a.getGroupPixelWidth();c.groupPixelWidth&&(c.hasProcessed=!0,c.applyGrouping())})};d.prototype.getGroupPixelWidth=function(){var a=this.series,c=a.length,b,h=0,d=!1,e;for(b=c;b--;)(e=a[b].options.dataGrouping)&&(h=Math.max(h,B(e.groupPixelWidth,y.groupPixelWidth)));for(b=c;b--;)if(e=a[b].options.dataGrouping)if(c=(a[b].processedXData||a[b].data).length,a[b].groupPixelWidth||c>this.chart.plotSizeX/
h||c&&e.forced)d=!0;return d?h:0};d.prototype.setDataGrouping=function(a,c){var b;c=B(c,!0);a||(a={forced:!1,units:null});if(this instanceof d)for(b=this.series.length;b--;)this.series[b].update({dataGrouping:a},!1);else this.chart.options.series.forEach(function(b){b.dataGrouping=a},!1);this.ordinal&&(this.ordinal.slope=void 0);c&&this.chart.redraw()};f(d,"postProcessData",d.prototype.applyGrouping);f(L,"update",function(){if(this.dataGroup)return G(24,!1,this.series.chart),!1});f(M,"headerFormatter",
function(a){var c=this.chart,b=c.time,d=a.labelConfig,g=d.series,e=g.tooltipOptions,f=g.options.dataGrouping,k=e.xDateFormat,n=g.xAxis,r=e[a.isFooter?"footerFormat":"headerFormat"];if(n&&"datetime"===n.options.type&&f&&q(d.key)){var t=g.currentDataGrouping;f=f.dateTimeLabelFormats||y.dateTimeLabelFormats;if(t)if(e=f[t.unitName],1===t.count)k=e[0];else{k=e[1];var l=e[2]}else!k&&f&&n.dateTime&&(k=n.dateTime.getXDateFormat(d.x,e.dateTimeLabelFormats));k=b.dateFormat(k,d.key);l&&(k+=b.dateFormat(l,d.key+
t.totalRange-1));g.chart.styledMode&&(r=this.styledModeFormat(r));a.text=C(r,{point:R(d.point,{key:k}),series:g},c);a.preventDefault()}});f(E,"destroy",r.destroyGroupedData);f(E,"afterSetOptions",function(a){a=a.options;var c=this.type,b=this.chart.options.plotOptions,d=N.defaultOptions.plotOptions[c].dataGrouping,e=this.useCommonDataGrouping&&y;if(K[c]||e){d||(d=F(y,K[c]));var f=this.chart.rangeSelector;a.dataGrouping=F(e,d,b.series&&b.series.dataGrouping,b[c].dataGrouping,this.userOptions.dataGrouping,
!a.isInternal&&f&&q(f.selected)&&f.buttonOptions[f.selected].dataGrouping)}});f(d,"afterSetScale",function(){this.series.forEach(function(a){a.hasProcessed=!1})});A.dataGrouping=J;"";return J});z(d,"masters/modules/datagrouping.src.js",[d["Extensions/DataGrouping.js"]],function(d){return d})});
//# sourceMappingURL=datagrouping.js.map